class Booking_App_Calendar {
	
	constructor(weekName, dateFormat, i18n){
	    
	    this._i18n = null;
	    if(typeof i18n == 'object'){
	        
	        console.log(typeof i18n);
	        this._i18n = i18n;
	        
	    }
		
		this.setWeekNameList(weekName);
		if(dateFormat != null){
		    
		    this._dateFormat = dateFormat;
		    
		}else{
		    
		    this._dateFormat = 0;
		    
		}
		
	}
	
	setWeekNameList(weekName){
	    
	    this._weekName = weekName;
	    
	}
	
	getWeekNameList(){
	    
	    return this._weekName;
	    
	}
	
	create(calendarPanel, calendarData, month, day, year, permission, callback){
	    
	    var dayHeight = parseInt(calendarPanel.clientWidth / 7);
	    console.log("dayHeight = " + dayHeight);
	    
	    var weekNamePanel = document.createElement("div");
	    weekNamePanel.setAttribute("class", "calendar");
	    var weekName = this.getWeekNameList();
	    for(var i = 0; i < 7; i++){
	  	
            var dayPanel = document.createElement("div");
            dayPanel.setAttribute("class", "dayPanel");
            dayPanel.textContent = weekName[i];
            weekNamePanel.appendChild(dayPanel);
            if(i == 6){
                
                dayPanel.setAttribute("style", "border-width: 1px 1px 0px 1px;")
	            
            }
        }
        
	    calendarPanel.appendChild(weekNamePanel);
        
        var lastDay = parseInt(calendarData['date']['lastDay']);
        var startWeek = parseInt(calendarData['date']['startWeek']);
        var lastWeek = parseInt(calendarData['date']['lastWeek']);
        
        
        var weekCount = 0;
        var count = lastDay + startWeek + (6 - lastWeek);
        var weekLine = count / 7;
        for(var i = 1; i <= count; i++){
            
            if(weekLine <= 0){
	            break;
	        }
            
            var className = 'dayPanel dayPanelHeight';
            var dayKey = i - startWeek;
            var day = dayKey;
            if(dayKey <= 0 || lastDay < dayKey){
                
                className = 'dayPanel dayPanelHeight closeDay';
                day = '-';
                
            }
            
            var textPanel = document.createElement("div");
            textPanel.setAttribute("class", "dayPostion");
            textPanel.textContent = day;
            
            var dayPanel = document.createElement("div");
            dayPanel.setAttribute("data-key", dayKey);
            //dayPanel.setAttribute("style", "height: " + dayHeight + "px;");
            dayPanel.setAttribute("class", className);
            dayPanel.appendChild(textPanel);
            weekNamePanel.appendChild(dayPanel);
            
            var data = {month: month, day: dayKey, year: year, eventPanel: dayPanel, status: true, count: i};
            if(calendarData.calendar[dayKey] != null || (calendarData.reservation != null && calendarData.reservation[dayKey])){
                
                dayPanel.setAttribute("class", "dayPanel dayPanelHeight pointer");
                if(parseInt(weekLine) == 1){
                    
                    dayPanel.setAttribute("class", "border_bottom_width dayPanel dayPanelHeight pointer");
                    
                }
                
                data.status = true;
                callback(data);
                
            }else{
                
                dayPanel.setAttribute("class", "dayPanel dayPanelHeight closeDay");
                if(parseInt(weekLine) == 1){
                    
                    dayPanel.setAttribute("class", "border_bottom_width dayPanel dayPanelHeight closeDay");
                    
                }
                
                data.status = false;
                callback(data);
                
            }
            
	        if(weekCount == 6){
                
                //dayPanel.setAttribute("style", "border-width: 1px 1px 0px 1px; height: " + dayHeight + "px;");
                var style = dayPanel.getAttribute("style");
                if(style == null){
                    
                    style = "";
                    
                }
                dayPanel.setAttribute("style", style + "border-width: 1px 1px 0px 1px;");
                
            }
            
            if(weekCount == 6){
                	
                weekCount = 0;
                weekLine--;
                
            }else{
                
                weekCount++;
                
            }
        
	    }
        
    }
	
	formatBookingDate(month, day, year, hour, min, title, week){
        
        var i18n = this._i18n;
        var dateFormat = this._dateFormat;
        console.log("dateFormat = " + dateFormat + " month = " + month + " day = " + day + " year = " + year + " hour = " + hour + " min = " + min + " week = " + week);
        if(month != null){
            
            month = ("0" + month).slice(-2);
            
        }
        
        if(day != null){
            
            day = ("0" + day).slice(-2);
            
        }
        
        if(hour != null){
            
            hour = ("0" + hour).slice(-2);
            
        }
        
        if(min != null){
            
            min = ("0" + min).slice(-2);
            
        }
        
        if(week != null){
            
            week = parseInt(week);
            
        }
        
        if(month != null && day == null && year == null){
            
            date = month;
            if(dateFormat == 2 || dateFormat == 5){
                
                var monthShortName = ['', i18n.get('Jan'), i18n.get('Feb'), i18n.get('Mar'), i18n.get('Apr'), i18n.get('May'), i18n.get('Jun'), i18n.get('Jul'), i18n.get('Aug'), i18n.get('Sep'), i18n.get('Oct'), i18n.get('Nov'), i18n.get('Dec')];
                date = monthShortName[parseInt(month)];
                
            }
            return date;
            
        }
        
        //var weekName = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
        var weekName = [i18n.get('Sunday'), i18n.get('Monday'), i18n.get('Tuesday'), i18n.get('Wednesday'), i18n.get('Thursday'), i18n.get('Friday'), i18n.get('Saturday')];
        var monthFullName = ['', i18n.get('January'), i18n.get('February'), i18n.get('March'), i18n.get('April'), i18n.get('May'), i18n.get('June'), i18n.get('July'), i18n.get('August'), i18n.get('September'), i18n.get('October'), i18n.get('November'), i18n.get('December')];
        var date = monthFullName[parseInt(month)] + " " + day + ", " + year + " ";
        
        if(dateFormat == 0){
            
            date = month + "/" + day + "/" + year + " ";
            if(day == null){
                
                date = month + "/" + year;
                
            }
            
        }else if(dateFormat == 1){
            
            date = month + "-" + day + "-" + year + " ";
            if(day == null){
                
                date = month + "-" + year;
                
            }
            
        }else if(dateFormat == 2){
            
            date = monthFullName[parseInt(month)] + " " + day + ", " + year + " ";
            if(day == null){
                
                date = monthFullName[parseInt(month)] + "," + year;
                
            }
            
        }else if(dateFormat == 3){
            
            date = day + "/" + month + "/" + year + " ";
            if(day == null){
                
                date = month + "/" + year;
                
            }
            
        }else if(dateFormat == 4){
            
            date = day + "-" + month + "-" + year + " ";
            if(day == null){
                
                date = month + "-" + year;
                
            }
            
        }else if(dateFormat == 5){
            
            date = day + " " + monthFullName[parseInt(month)] + ", " + year + " ";
            if(day == null){
                
                date = monthFullName[parseInt(month)] + "," + year;
                
            }
            
        }else if(dateFormat == 6){
            
            date = year + "/" + month + "/" + day + " ";
            if(day == null){
                
                date = month + "/" + year;
                
            }
            
        }else if(dateFormat == 7){
            
            date = year + "-" + month + "-" + day + " ";
            if(day == null){
                
                date = month + "-" + year;
                
            }
            
        }else{
            
        }
        
        if(dateFormat != 2 && week != null){
            
            date = weekName[week] + " " + date;
            
        }else if(dateFormat == 2 && week != null){
            
            date = weekName[week] + ", " + date;
            
        }
        
        if(hour != null && min != null){
            date += hour + ":" + min + " ";
        }
        
        if(title != null){
            date += title;
        }
        
        return date;
        
    }
	
}