var schedule_data = schedule_data;
const url = schedule_data['url'];
const nonce = schedule_data['nonce'];
const action = schedule_data['action'];
const dateFormat = schedule_data.dateFormat;
var settingList = schedule_data['list'];
var upgradeData = {url: schedule_data['url'], nonce: schedule_data['nonce'], action: schedule_data['action'], locale: schedule_data.locale};
var xmlHttp = null;
var template_schedule_list = {};
var date = {};
var weekKey = 0;
var mode = null;
var i18n = null;

var blockPanel = null;
var editPanel = null;
var loadingPanel = null;
var buttonPanel = null;
var template_schedule_save_button = null;

var monthFullName = ['', 'January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
var monthShortName = ['', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
//var weekName = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
var weekName = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];

window.onload = function(){
    
    console.log(schedule_data);
    console.log(booking_package_dictionary);
    i18n = new I18n(schedule_data.locale);
    i18n.setDictionary(booking_package_dictionary);
    
    blockPanel = document.getElementById("blockPanel");
    editPanel = document.getElementById("editPanel");
    loadingPanel = document.getElementById("loadingPanel");
    buttonPanel = document.getElementById("buttonPanel");
    /**
    var loadingImg = document.createElement("img")
    loadingImg.src = "images/loading_0.gif";
    loadingPanel.appendChild(loadingImg);
    **/
    
    //template_schedule_save_button = document.getElementById("template_schedule_save_button");
    
    blockPanel.onclick = function(){
        
        document.getElementById("email_edit_panel").classList.add("hidden_panel");
        buttonPanel.textContent = null;
        editPanelShow(false);
        
    }
    
    document.getElementById("media_modal_close").onclick = function(){
        
        document.getElementById("email_edit_panel").classList.add("hidden_panel");
        buttonPanel.textContent = null;
        editPanelShow(false);
        
    }
    
    getCalendarAccountListData(parseInt(schedule_data['month']), 1, parseInt(schedule_data['year']));
    
    
}

var getMode = function(){
    
    return this.mode;
    
}

var getCalendarDate = function(){
    
    return this.date;
    
}

var setCalendarDate = function(newDate){
    
    this.date = newDate;
    
}

var getCalendarAccountListData = function(month, day, year){
    
    loadingPanel.setAttribute("class", "loading_modal_backdrop");
    var post = {nonce: nonce, action: action, mode: 'getCalendarAccountListData', year: year, month: month, day: day};
    xmlHttp = new Booking_App_XMLHttp(url, post, function(accountList){
            
        loadingPanel.setAttribute("class", "hidden_panel");
        console.log(accountList);
        createCalendarAccountList(accountList, month, day, year);
            
    });
    
}

var getAccountScheduleData = function(month, day, year, account){
    
    loadingPanel.setAttribute("class", "loading_modal_backdrop");
    var post = {nonce: nonce, action: action, mode: 'getAccountScheduleData', year: year, month: month, day: day};
    if(account != null){
        
        post.accountKey = account.key;
        
    }
    xmlHttp = new Booking_App_XMLHttp(url, post, function(calendarData){
            
        loadingPanel.setAttribute("class", "hidden_panel");
        console.log(calendarData);
        createCalendar(calendarData, month, day, year, account);
            
    });
    
}

var createCalendarAccountList = function(accountList, month, day, year){
    
    console.log("calendarAccountList");
    console.log(accountList);
    
    var calendarAccountList = document.getElementById("calendarAccountList");
    calendarAccountList.classList.remove("hidden_panel");
    
    var addCalendarAccountButton = document.getElementById("add_new_calendar");
    addCalendarAccountButton.onclick = function(){
        
        addItem(calendarAccountList, 'addCalendarAccount', null, schedule_data['elementForCalendarAccount'], function(json){
            
            console.log(json);
            if(json != 'close'){
                
                createCalendarAccountList(json, month, day, year);
                
            }
            
        });
        
    }
    
    var table = document.getElementById("calendar_list_table");
    table.textContent = null;
    
    var titleTr = document.createElement("tr");
    table.appendChild(titleTr);
    
    var list = {key: 'ID', name: i18n.get('Name'), status: i18n.get('Status'), type: i18n.get('Type'), shortCode: i18n.get('Short Code')};
    console.log("schedule_data.calendarAccountType = " + parseInt(schedule_data.calendarAccountType))
    if(parseInt(schedule_data.calendarAccountType) == 0){
        
        delete list.type;
        
    }
    for(var key in list){
        
        console.log(list[key]);
        var elementName = document.createElement("div");
        elementName.textContent = list[key];
        
        var td = document.createElement("td");
        td.appendChild(elementName);
        titleTr.appendChild(td);
        
    }
    
    var calendarAccountClick = true;
    for(var i = 0; i < accountList.length; i++){
        
        var account = accountList[i];
        console.log(account);
        var tr = document.createElement("tr");
        tr.setAttribute("data-key", i);
        tr.classList.add("pointer");
        table.appendChild(tr);
        for(var key in list){
            
            console.log(account[key]);
            var elementName = document.createElement("div");
            elementName.textContent = account[key];
            if(key == 'shortCode'){
                
                elementName.classList.add("shortCode");
                elementName.textContent = "[booking_package id=" + account['key'] + "]";
                elementName.onclick = function(){
                    
                    console.log("elementName click");
                    calendarAccountClick = false;
                    
                }
                elementName.onmouseout = function(){
                    
                    calendarAccountClick = true;
                    
                }
                
            }else{
                
                if(key != 'name'){
                    
                    elementName.textContent = account[key].toUpperCase();
                    
                }
                
            }
            
            var td = document.createElement("td");
            td.appendChild(elementName);
            tr.appendChild(td);
            tr.onclick = function(){
                
                if(calendarAccountClick === true){
                    
                    console.log("tr click");
                    calendarAccountList.classList.add("hidden_panel");
                    var accountId = parseInt(this.getAttribute("data-key"));
                    loadTabFrame(accountList, month, day, year, accountList[accountId]);
                    
                }
                
            }
            
        }
        
    }
    
    
}

function loadTabFrame(accountList, month, day, year, account){
	
	console.log(account);
	//createSettingPanel();
	
	
	var tabFrame = document.getElementById("tabFrame");
	tabFrame.classList.remove("hidden_panel");
	var menuList = {calendarLink: 'calendarPage', formLink: 'formPanel', courseLink: 'coursePanel', emailLink: 'emailPanel', settingLink: 'settingPanel'};
	for(var key in menuList){
		
		console.log(menuList[key]);
		var button = document.getElementById(key);
		button.setAttribute("data-key", key);
		
		if(key == 'calendarLink'){
		    
		    document.getElementById(key).setAttribute("class", "menuItem active");
			document.getElementById(menuList[key]).setAttribute("class", "");
		    
		}else{
		    
		    document.getElementById(key).setAttribute("class", "menuItem");
			document.getElementById(menuList[key]).setAttribute("class", "hidden_panel");
		    
		}
		
		button.onclick = function(event){
			
			var clickKey = this.getAttribute("data-key");
			console.log(clickKey);
			for(var key in menuList){
				
				var link = document.getElementById(key);
				var panel = document.getElementById(menuList[key]);
				if(clickKey == key){
					
					link.setAttribute("class", "menuItem active");
					panel.setAttribute("class", "");
					
					if(clickKey == 'calendarLink'){
						
						getAccountScheduleData(month, day, year, account);
						//createFormPanel();
						
					}else if(clickKey == 'formLink'){
						
						//createCoursePanel();
						loadingPanel.setAttribute("class", "loading_modal_backdrop");
                        var post = {nonce: nonce, action: action, mode: 'getForm', accountKey: account.key};
                        xmlHttp = new Booking_App_XMLHttp(url, post, function(formList){
                            
                            loadingPanel.setAttribute("class", "hidden_panel");
                            console.log(formList);
                            createFormPanel(formList, account);
                            
                        });
						
					}else if(clickKey == 'courseLink'){
						
						loadingPanel.setAttribute("class", "loading_modal_backdrop");
                        var post = {nonce: nonce, action: action, mode: 'getCourseList', accountKey: account.key};
                        xmlHttp = new Booking_App_XMLHttp(url, post, function(courseList){
                            
                            loadingPanel.setAttribute("class", "hidden_panel");
                            console.log(courseList);
                            createCoursePanel(courseList, account);
                            
                        });
						//settingPanel();
						
					}else if(clickKey == 'emailLink'){
					    
					    loadingPanel.setAttribute("class", "loading_modal_backdrop");
                        var post = {nonce: nonce, action: action, mode: 'getEmailMessageList', accountKey: account.key};
                        xmlHttp = new Booking_App_XMLHttp(url, post, function(json){
                            
                            loadingPanel.setAttribute("class", "hidden_panel");
                            console.log(json);
                            emailSettingPanel(json.emailMessageList, json.formData, account);
                            
                        });
					    
					}else if(clickKey == 'settingLink'){
						
						settingPanel(accountList, month, day, year, account, function(json){
						    
						    accountList = json;
						    for(var i in json){
                                
                                if(json[i].key == account.key){
                                    
                                    account = json[i];
                                    break;
                                    
                                }
                                
                            }
						    
						});
						
					}
					
				}else{
					
					link.setAttribute("class", "menuItem");
					panel.setAttribute("class", "hidden_panel");
					
				}
				
			}
			
		}
		
	}
	
	var return_to_calendar_list = document.getElementById("return_to_calendar_list");
	return_to_calendar_list.onclick = function(){
	    
	    tabFrame.classList.add("hidden_panel");
	    createCalendarAccountList(accountList, month, day, year);
	    
	}
	
	getAccountScheduleData(month, day, year, account);
	
}

var createCalendar = function(calendarData, month, day, year, account){
    
    
    console.log(typeof month);
    this.date = {month: month, day: day, year: year};
    var calendarPanel = document.getElementById("calendarPage");
    calendarPanel.textContent = null;
    
    if(document.getElementById("save_setting") == null){
        
        var save_setting = document.createElement("button");
        save_setting.setAttribute("class", "w3tc-button-save button-primary");
        save_setting.textContent = i18n.get("Edit schedule");
        calendarPanel.appendChild(save_setting);
        save_setting.onclick = function(){
            
            editTemplateSchedule(0, account);
            
        }
        
    }
    
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	var calendar = new Booking_App_Calendar(weekName, dateFormat, i18n);
    
    var dayHeight = parseInt(calendarPanel.clientWidth / 7);
	console.log("dayHeight = " + dayHeight);
	
	var datePanel = document.createElement("div");
	datePanel.setAttribute("class", "calendarData");
	datePanel.textContent = calendar.formatBookingDate(month, null, year, null, null, null);
	
	console.log(year + "/" + month);
	
	var returnLabel = document.createElement("label");
	returnLabel.setAttribute("class", "arrowLeft");
	if(month == 1){
	    
	    returnLabel.textContent = "＜" + calendar.formatBookingDate(12, null, null, null, null, null);
	    
	}else{
	    
	    returnLabel.textContent = "＜" + calendar.formatBookingDate((month - 1), null, null, null, null, null);;
	    
	}
	
	
	var returnPanel = document.createElement("div");
	returnPanel.setAttribute("class", "calendarChangeButton");
	returnPanel.appendChild(returnLabel);
	
	var nextLabel = document.createElement("label");
	nextLabel.setAttribute("class", "arrowRight");
	if(month == 12){
	    
	    nextLabel.textContent = calendar.formatBookingDate(1, null, null, null, null, null) + "＞";
	    
	}else{
	    
	    nextLabel.textContent = calendar.formatBookingDate((month + 1), null, null, null, null, null) + "＞";
	    
	}
	var nextPanel = document.createElement("div");
	nextPanel.setAttribute("style", "text-align: right;");
	nextPanel.setAttribute("class", "calendarChangeButton");
	nextPanel.appendChild(nextLabel);
	
	var topPanel = document.createElement("div");
	topPanel.setAttribute("class", "calendarPanel");
	topPanel.appendChild(returnPanel);
	topPanel.appendChild(datePanel);
	topPanel.appendChild(nextPanel);
	calendarPanel.appendChild(topPanel);
	
	
	calendar.create(calendarPanel, calendarData, month, day, year, '', function(callback){
	    
	    console.log(callback);
	    var dayPanel = callback['eventPanel'];
	    dayPanel.onclick = function(){
				
			var dayKey = this.getAttribute("data-key");
			setCalendarDate({month: month, day: dayKey, year: year});
			editPublicSchedule(month, dayKey, year, account, function(callback){
			    
			    console.log("editPublicSchedule callback");
			    
			});
			
		}
	    
	});
	
	returnLabel.onclick = function(){
	    
	    if(month == 1){
			
			year--;
			month = 12;
			
		}else{
			
			month--;
			
		}
		
		getAccountScheduleData(month, 1, year, account);
	    
	}
	
	nextLabel.onclick = function(){
	    
	    if(month == 12){
			
			year++;
			month = 1;
			
		}else{
			
			month++;
			
		}
		
		getAccountScheduleData(month, 1, year, account);
	    
	}
    
}

var editPublicSchedule = function(month, day, year, account, callback){
    
    var weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
	var calendar = new Booking_App_Calendar(weekName, dateFormat, i18n);
    
    document.getElementById("media_frame_content").textContent = null;
    var edit_title = document.getElementById("edit_title");
    //edit_title.textContent = monthFullName[month] + " " + day + ", " + year;
    edit_title.textContent = calendar.formatBookingDate(month, day, year, null, null, null);
    
    document.getElementById("media_router").classList.remove("hidden_panel");
    document.getElementById("remainder").setAttribute("class", "td_width_50_px pointer");
    document.getElementById("delete").setAttribute("class", "td_width_50_px pointer");
    document.getElementById("menu_panel").setAttribute("class", "media_frame_menu hidden_panel");
    //document.getElementById("media_title").setAttribute("class", "media_left_zero");
    document.getElementById("media_title").classList.add("media_left_zero");
    //document.getElementById("media_router").setAttribute("class", "media_left_zero");
    document.getElementById("media_router").classList.add("media_left_zero");
    document.getElementById("media_frame_content").setAttribute("class", "media_left_zero");
    document.getElementById("frame_toolbar").setAttribute("class", "media_frame_toolbar media_left_zero");
    
    getPublicSchedule(month, day, year, account, callback);
    editPanelShow(true);
    
}

var editTemplateSchedule = function(weekKey, account){
    
    
    document.getElementById("media_frame_content").textContent = null;
    var edit_title = document.getElementById("edit_title");
    edit_title.textContent = i18n.get("Schedule setting");
    var media_menu = document.getElementById("media_menu");
    media_menu.textContent = null;
    
    document.getElementById("media_router").classList.remove("hidden_panel");
    document.getElementById("remainder").setAttribute("class", "hidden_panel");
    document.getElementById("delete").setAttribute("class", "hidden_panel");
    document.getElementById("menu_panel").setAttribute("class", "media_frame_menu");
    //document.getElementById("media_title").setAttribute("class", "media_frame_title");
    //media_left_zero
    document.getElementById("media_title").classList.remove("media_left_zero");
    //document.getElementById("media_router").setAttribute("class", "media_frame_router");
    document.getElementById("media_router").classList.remove("media_left_zero");
    document.getElementById("media_frame_content").setAttribute("class", "");
    document.getElementById("frame_toolbar").setAttribute("class", "media_frame_toolbar");
    
    var weekPanelList = [];
    var weekList = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
    for(var i = 0; i < weekList.length; i++){
        
        var div = document.createElement("div");
        div.setAttribute("data-key", i);
        div.textContent = i18n.get(weekList[i]);
        div.onclick = function(){
            
            for(var i = 0; i < weekPanelList.length; i++){
                
                weekPanelList[i].setAttribute("class", "");
                
            }
            var key = this.getAttribute("data-key");
            //edit_title.textContent = "Schedule setting on " + weekList[key];
            edit_title.textContent = i18n.get("Schedule setting on %s", [i18n.get(weekList[key])]);
            this.setAttribute("class", "media_active");
            document.getElementById("media_frame_content").textContent = null;
            getTemplateSchedule(key, account);
            
        }
        
        weekPanelList.push(div);
        media_menu.appendChild(div);
        
    }
    
    if(weekKey != null){
        
        var key = parseInt(weekKey);
        edit_title.textContent = i18n.get("Schedule setting on %s", [i18n.get(weekList[key])]);
        weekPanelList[key].setAttribute("class", "media_active");
        getTemplateSchedule(key, account);
        
    }
    
    editPanelShow(true);
    
}

var getPublicSchedule = function(month, day, year, account, callback){
    
    //buttonPanel
    console.log(account);
    var deleteButton = document.createElement("button");
    deleteButton.textContent = i18n.get("Delete");
    deleteButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
    deleteButton.setAttribute("style", "margin-right: 10px;");
    
    var saveButton = document.createElement("button");
    saveButton.textContent = i18n.get("Save");
    saveButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
    
    buttonPanel.textContent = null;
    //buttonPanel.appendChild(deleteButton);
    buttonPanel.appendChild(saveButton);
    
    
    loadingPanel.setAttribute("class", "loading_modal_backdrop");
    var post = {nonce: nonce, action: action, mode: 'getPublicSchedule', month: month, day: day, year: year};
    if(account != null){
        
        post.accountKey = account.key;
        
    }
    xmlHttp = new Booking_App_XMLHttp(url, post, function(json){
            
        console.log(json);
        createSchedulePanel(weekKey, json, 'getPublicSchedule');
        loadingPanel.setAttribute("class", "hidden_panel");
            
    });
    
    deleteButton.onclick = function(event){
        
        loadingPanel.setAttribute("class", "loading_modal_backdrop");
        var post = {nonce: nonce, action: action, mode: "deletePublicSchedule", month: month, day: day, year: year};
        xmlHttp = new Booking_App_XMLHttp(url, post, function(json){
            
            callback(json);
            loadingPanel.setAttribute("class", "hidden_panel");
            console.log(json);
            
        });
        
    }
    
    saveButton.onclick = function(event){
        
        updateAccountSchedule(template_schedule_list, "updateAccountSchedule", account, callback);
        
    }
    
}

var getTemplateSchedule = function(weekKey, account){
    
    
    var saveButton = document.createElement("button");
    saveButton.textContent = i18n.get("Save");
    saveButton.setAttribute("class", "button media-button button-primary button-large media-button-insert");
    buttonPanel.textContent = null;
    buttonPanel.appendChild(saveButton);
    
    loadingPanel.setAttribute("class", "loading_modal_backdrop");
    var post = {nonce: nonce, action: action, mode: 'getTemplateSchedule', weekKey: weekKey};
    if(account != null){
        
        post.accountKey = account.key;
        
    }
    xmlHttp = new Booking_App_XMLHttp(url, post, function(json){
            
        console.log(json);
        createSchedulePanel(weekKey, json);
        loadingPanel.setAttribute("class", "hidden_panel", 'getTemplateSchedule');
            
    });
    
    saveButton.onclick = function(event){
        
        updateAccountSchedule(template_schedule_list, "updateAccountTemplateSchedule", account, null);
        
    }
    
}

var createSchedulePanel = function(weekKey, scheduleData, mode){
    
    console.log("weekKey = " + weekKey);
    console.log("mode = " + mode);
    this.mode = mode;
    this.weekKey = weekKey;
    var media_frame_content = document.getElementById("media_frame_content");
    media_frame_content.textContent = null;
    template_schedule_list = {};
    
    
    var timePanelList = {};
    var hourBlockList = {};
    var minBlockList = {};
    var capacityBlockList = {};
    var remainderBlockList = {};
    var dotList = {};
    
    var table = document.createElement("table");
    table.setAttribute("class", "wp-list-table widefat fixed striped");
    media_frame_content.appendChild(table);
    
    for(var i = 0; i < 100; i++){
        
        var th = document.createElement("th");
        th.textContent = (i + 1);
        
        var timePanel = document.createElement("div");
        timePanel.setAttribute("class", "noTime");
        timePanel.setAttribute("data-select", i);
        timePanel.onclick = function(){
            
            var timePanel = this;
            var select = timePanel.getAttribute("data-select");
            timePanel.setAttribute("class", "hidden_panel");
            var hourPanel = hourBlockList[select];
            hourPanel.setAttribute("class", "hour");
            hourPanel.textContent = "00";
            hourPanel.removeAttribute("data-key");
            
            dotList[select].setAttribute("class", "dot");
            
            var minPanel = minBlockList[select];
            minPanel.setAttribute("class", "min");
            minPanel.textContent = "00";
            minPanel.removeAttribute("data-key");
            selectAction(hourPanel, hourPanel, "hour", "hour", "hour", 24, function(boolean){
                
                console.log("boolean = " + boolean);
                if(boolean === true){
                    
                    template_schedule_list[select].delete.checked = false;
                    dotList[select].setAttribute("class", "dot");
                    selectAction(minPanel, minPanel, "minutes", "min", "min", 60, function(boolean){
                        
                        console.log("boolean = " + boolean);
                        if(boolean == true){
                            
                            template_schedule_list[select].delete.checked = false;
                            timePanel.setAttribute("class", "hidden_panel");
                            var capacityPanel = capacityBlockList[select];
                            selectAction(capacityPanel, capacityPanel, "Capacity", "person", "noPerson", 100, function(boolean){
                                
                                console.log("boolean = " + boolean);
                                if(boolean === false){
                                    
                                    capacityPanel.textContent = "";
                                    
                                }else{
                                    
                                    if(boolean != "close"){
                                        
                                        template_schedule_list[select].delete.checked = false;
                                        var value = capacityPanel.getAttribute("data-key");
                                        var remainderPanel = remainderBlockList[select];
                                        remainderPanel.setAttribute("data-key", value);
                                        remainderPanel.setAttribute("class", "person");
                                        remainderPanel.textContent = ("0" + value).slice(-2);
                                        
                                    }
                                    
                                    /**
                                    selectAction(remainderPanel, remainderPanel, "Capacity", "person", "noPerson", 100, function(boolean){
                                        
                                        console.log("boolean = " + boolean);
                                        if(boolean === false){
                                            
                                            panel.textContent = "";
                                            
                                        }
                                        
                                    });
                                    **/
                                }
                            
                            });
                            
                        }else if(boolean === true || boolean == "close"){
                            
                            timePanel.setAttribute("class", "noTime");
                            hourPanel.setAttribute("class", "hidden_panel");
                            dotList[select].setAttribute("class", "hidden_panel");
                            minPanel.setAttribute("class", "hidden_panel");
                            
                        }
                        
                    });
                    
                }else if(boolean === true || boolean == "close"){
                    
                    timePanel.setAttribute("class", "noTime");
                    hourPanel.setAttribute("class", "hidden_panel");
                    dotList[select].setAttribute("class", "hidden_panel");
                    minPanel.setAttribute("class", "hidden_panel");
                    
                }
                
            });
            
        }
        
        
        var hourBlock = document.createElement("div");
        hourBlock.setAttribute("data-select", i);
        hourBlock.setAttribute("class", "hour");
        hourBlock.textContent = "";
        hourBlock.onclick = function(event){
            
            var panel = this;
            var select = panel.getAttribute("data-select");
            selectAction(panel, panel, "hour", "hour", "hour", 24, function(boolean){
                
                console.log("boolean = " + boolean);
                if(boolean === false){
                    
                    timePanelList[select].setAttribute("class", "noTime");
                    hourBlockList[select].setAttribute("class", "hidden_panel");
                    dotList[select].setAttribute("class", "hidden_panel");
                    minBlockList[select].setAttribute("class", "hidden_panel");
                    console.log(template_schedule_list[select]);
                    template_schedule_list[select].delete.checked = true;
                    
                }else{
                    
                    template_schedule_list[select].delete.checked = false;
                    
                }
                
            });
            
        }
        
        var dot = document.createElement("span");
        dot.setAttribute("class", "dot");
        dot.textContent = " : ";
        
        var minBlock = document.createElement("div");
        minBlock.setAttribute("data-select", i);
        minBlock.setAttribute("class", "min");
        minBlock.textContent = "";
        minBlock.onclick = function(event){
            
            var panel = this;
            var select = panel.getAttribute("data-select");
            selectAction(panel, panel, "minutes", "min", "min", 60, function(boolean){
                
                console.log("boolean = " + boolean);
                if(boolean === false){
                    
                    timePanelList[select].setAttribute("class", "noTime");
                    hourBlockList[select].setAttribute("class", "hidden_panel");
                    dotList[select].setAttribute("class", "hidden_panel");
                    minBlockList[select].setAttribute("class", "hidden_panel");
                    template_schedule_list[select].delete.checked = true;
                    
                }else{
                    
                    template_schedule_list[select].delete.checked = false;
                    
                }
                
            });
            
        }
        
        timePanel.appendChild(hourBlock);
        timePanel.appendChild(dot);
        timePanel.appendChild(minBlock);
        
        var timeTd = document.createElement("td");
        timeTd.setAttribute("class", "timeTd");
        timeTd.appendChild(timePanel);
        timeTd.appendChild(hourBlock);
        timeTd.appendChild(dot);
        timeTd.appendChild(minBlock);
        
        var titleBox = document.createElement("input");
        titleBox.setAttribute("class", "regular-text title_text_box");
        titleBox.type = "text";
        
        var titleTd = document.createElement("td");
        titleTd.appendChild(titleBox);
        
        var capacityBlock = document.createElement("div");
        capacityBlock.setAttribute("class", "noPerson");
        capacityBlock.setAttribute("data-select", i);
        capacityBlock.onclick = function(event){
            
            var panel = this;
            var select = panel.getAttribute("data-select");
            selectAction(panel, panel, "Capacity", "person", "noPerson", 100, function(boolean){
                
                console.log("boolean = " + boolean);
                if(boolean === false){
                    
                    panel.textContent = "";
                    template_schedule_list[select].delete.checked = true;
                    
                }else{
                    
                    template_schedule_list[select].delete.checked = false;
                    
                }
                
            });
            
        }
        
        var capacityTd = document.createElement("td");
        capacityTd.setAttribute("class", "td_width_50_px");
        capacityTd.appendChild(capacityBlock);
        
        var remainderBlock = document.createElement("div");
        remainderBlock.setAttribute("class", "noPerson");
        remainderBlock.setAttribute("data-select", i);
        remainderBlock.onclick = function(event){
            
            var panel = this;
            var select = panel.getAttribute("data-select");
            selectAction(panel, panel, "Remainder", "person", "noPerson", 100, function(boolean){
                
                console.log("boolean = " + boolean);
                console.log(template_schedule_list[select]);
                if(boolean === false){
                    
                    panel.textContent = "";
                    template_schedule_list[select].delete.checked = true;
                    
                }else{
                    
                    template_schedule_list[select].delete.checked = false;
                    
                }
                
            });
            
        }
        
        timePanelList[i] = timePanel;
        hourBlockList[i] = hourBlock;
        minBlockList[i] = minBlock;
        dotList[i] = dot;
        capacityBlockList[i] = capacityBlock;
        remainderBlockList[i] = remainderBlock;
        
        var remainderTd = document.createElement("td");
        remainderTd.setAttribute("class", "td_width_50_px");
        remainderTd.appendChild(remainderBlock);
        
        var checkBox = document.createElement("input");
		checkBox.name = "check_" + i;
		checkBox.type = "checkbox";
		checkBox.value = "true";
		
		var stopTd = document.createElement("td");
		stopTd.setAttribute("class", "td_width_50_px");
		stopTd.appendChild(checkBox);
        
        var deletekBox = document.createElement("input");
		deletekBox.name = "check_" + i;
		deletekBox.type = "checkbox";
		deletekBox.value = "true";
		
		var deleteTd = document.createElement("td");
		deleteTd.setAttribute("class", "td_width_50_px");
		deleteTd.appendChild(deletekBox);
        
        var tr = document.createElement("tr");
        tr.appendChild(th);
        tr.appendChild(timeTd);
        tr.appendChild(titleTd);
        tr.appendChild(capacityTd);
        tr.appendChild(remainderTd);
        tr.appendChild(stopTd);
        tr.appendChild(deleteTd);
        table.appendChild(tr);
        
        if(mode != 'getPublicSchedule'){
            
            tr.removeChild(remainderTd);
            tr.removeChild(deleteTd);
            
        }
        
        //var schedule_data = {hour: hourSelectClone, min: minSelectClone, title: titleBox, cost: null, capacity: capacitySelectClone, remainder: remainderSelectClone, stop: checkBox, delete: deletekBox};
        var schedule_data = {hour: hourBlock, min: minBlock, title: titleBox, cost: null, capacity: capacityBlock, remainder: remainderBlock, stop: checkBox, delete: deletekBox};
        
        if(scheduleData[i] != null){
            
            console.log(i);
            console.log(scheduleData[i]);
            
            timePanel.setAttribute("class", "hidden_panel");
            
            hourBlock.textContent = (0 + scheduleData[i]['hour']).slice(-2);
            hourBlock.setAttribute("data-key", scheduleData[i]['hour']);
            hourBlock.setAttribute("data-default", scheduleData[i]['hour']);
            hourBlock.setAttribute("class", "hour");
            
            dot.setAttribute("class", "dot");
            
            minBlock.textContent = (0 + scheduleData[i]['min']).slice(-2);
            minBlock.setAttribute("data-key", scheduleData[i]['min']);
            minBlock.setAttribute("data-default", scheduleData[i]['min']);
            minBlock.setAttribute("class", "min");
            
            titleBox.value = scheduleData[i]['title'];
            
            capacityBlock.textContent = (0 + scheduleData[i]['capacity']).slice(-2);
            capacityBlock.setAttribute("data-key", scheduleData[i]['capacity']);
            capacityBlock.setAttribute("data-default", scheduleData[i]['capacity']);
            capacityBlock.setAttribute("class", "person");
            
            if(scheduleData[i]['stop'] == 'true'){
                
                checkBox.checked = true;
                
            }
            
            if(mode == 'getPublicSchedule'){
                
                remainderBlock.textContent = (0 + scheduleData[i]['remainder']).slice(-2);
                remainderBlock.setAttribute("data-key", scheduleData[i]['remainder']);
                remainderBlock.setAttribute("data-default", scheduleData[i]['remainder']);
                remainderBlock.setAttribute("class", "person");
                
                if(scheduleData[i]['delete'] != null && scheduleData[i]['delete'] == 'true'){
                
                    checkBox.checked = true;
                
                }
                
                if(scheduleData[i]['key'] != null){
                    
                    schedule_data['key'] = scheduleData[i]['key'];
                    
                }
                
            }
            
        }else{
            
            timePanel.setAttribute("class", "noTime");
            hourBlock.setAttribute("class", "hidden_panel");
            dot.setAttribute("class", "hidden_panel");
            minBlock.setAttribute("class", "hidden_panel");
            
        }
        
        
        template_schedule_list[i] = schedule_data;
        
        
    }
    
    var selectAction = function(panel, targetPanel, title, classTrue, classFalse, max, callback){
        
        var key = null;
        if(panel.getAttribute("data-key") != null){
            
            key = panel.getAttribute("data-key");
        
        }
        var rect = panel.getBoundingClientRect();
        var confirm = new Confirm();
        title = i18n.get("Choose %s", [title]);
        confirm.selectListPanel(panel, title, 0, max, 5, key, function(response){
            
            console.log(response);
            if(response !== false && callback != null){
                
                console.log("response = " + response);
                if(response != "--" && response != "close"){
                    
                    targetPanel.textContent = ("0" + response).slice(-2);
                    targetPanel.setAttribute("data-key", response);
                    targetPanel.setAttribute("class", classTrue);
                    callback(true);
                    
                }else if(response == "close"){
                    
                    callback(response);
                    
                }else{
                    
                    //panel.textContent = "--";
                    targetPanel.removeAttribute("data-key");
                    targetPanel.setAttribute("class", classFalse);
                    callback(false);
                    
                }
                
                
            }else if(response === false){
                
                callback(response);
                
            }
            
        });
        
    }
    
    var deleteBool = true;
    var deleteButton = document.getElementById("delete");
    deleteButton.removeEventListener("click", event);
    deleteButton.onclick = function(event){
        
        console.log("deleteButton.onclick");
        
        for(var key in template_schedule_list){
            
            template_schedule_list[key]["delete"].checked = deleteBool;
            
        }
        
        if(deleteBool == false){
                
            deleteBool = true;
            
        }else{
            
            deleteBool = false;
            
        }
        
    }
    
    var stopBool = true;
    var stopButton = document.getElementById("stop");
    console.log(stopButton);
    stopButton.removeEventListener("click", event);
    stopButton.onclick = function(){
        
        console.log("stopButton.onclick");
        
        for(var key in template_schedule_list){
            
            template_schedule_list[key]["stop"].checked = stopBool;
            
        }
        
        if(stopBool == false){
                
            stopBool = true;
            
        }else{
            
            stopBool = false;
            
        }
        
    }
    
}


var updateAccountSchedule = function(template_schedule_list, mode, account, callback){
    
    console.log(weekKey);
    console.log(template_schedule_list);
    var i = 0;
    var post = {nonce: nonce, action: action, mode: mode, weekKey: weekKey};
    if(mode == 'updateAccountSchedule'){
        
        var date = getCalendarDate();
        post = {nonce: nonce, action: action, mode: mode, weekKey: weekKey, month: date['month'], day: date['day'], year: date['year']};
        
    }
    
    if(account != null){
        
        post.accountKey = account.key;
        
    }
    
    for(var key in template_schedule_list){
        
        console.log(data);
        var data = template_schedule_list[key];
        var hourValue, minValue, capacityValue = null;
        if(data['hour'].getAttribute("data-key") != null && data['min'].getAttribute("data-key") != null && data['capacity'].getAttribute("data-key") != null){
                
            hourValue = data['hour'].getAttribute("data-key");
            minValue = data['min'].getAttribute("data-key");
            capacityValue = data['capacity'].getAttribute("data-key");
            
        }else{
            
            if(data['hour'].getAttribute("data-default") != null && data['min'].getAttribute("data-default") != null && data['capacity'].getAttribute("data-default") != null){
                
                hourValue = data['hour'].getAttribute("data-default");
                minValue = data['min'].getAttribute("data-default");
                capacityValue = data['capacity'].getAttribute("data-default");
                
            }
            
        }
        
        if(hourValue != null && minValue != null && capacityValue != null){
            
            var titleValue = data['title'].value;
            var stopValue = "false";
            if(data['stop'].checked == true){
                
                stopValue = "true";
                
            }
            
            console.log("key = " + template_schedule_list[key]['key'] + " " + hourValue + ":" + minValue + " capacity = " + capacityValue + " title = " + titleValue + " stop = " + stopValue);
            
            post['hour' + i] = hourValue;
            post['min' + i] = minValue;
            post['title' + i] = titleValue;
            post['cost' + i] = "";
            post['capacity' + i] = capacityValue;
            post['remainder' + i] = capacityValue;
            post['stop' + i] = stopValue;
            post['delete' + i] = "false";
            
            if(mode == 'updateAccountSchedule'){
                
                if(template_schedule_list[key]['key'] != null){
                    
                    post['key' + i] = template_schedule_list[key]['key'];
                    
                }
                
                var remainder = data['remainder'];
                if(remainder.getAttribute("data-key") != null){
                    
                    post['remainder' + i] = remainder.getAttribute("data-key");
                    
                }else{
                    
                    post['remainder' + i] = remainder.getAttribute("data-default");
                    if(remainder.getAttribute("data-default") == null){
                        
                        post['remainder' + i] = capacityValue;
                        
                    }
                    
                }
                
                /**
                var remainderKey = data['remainder'].selectedIndex;
                post['remainder' + i] = data['remainder'].options[remainderKey].value;
                **/
                
                var deleteValue = "false";
                if(data['delete'].checked == true){
                    
                    deleteValue = "true";
                    
                }
                post['delete' + i] = deleteValue;
                
            }else {
                
                post['key' + i] = (i + 1);
                var deleteValue = "false";
                if(data['delete'].checked == true){
                    
                    deleteValue = "true";
                    
                }
                post['delete' + i] = deleteValue;
                
            }
            
            i++;
            post['timeCount'] = i;
            
        }
        
        
    }
    
    console.log(post);
    //return null;
    
    if(i != 0){
        
        loadingPanel.setAttribute("class", "loading_modal_backdrop");
        xmlHttp = new Booking_App_XMLHttp(url, post, function(json){
            
            loadingPanel.setAttribute("class", "hidden_panel");
            console.log(json);
            if(callback != null){
                
                callback(json);
                
            }
            
            var date = getCalendarDate();
            getAccountScheduleData(date.month, 1, date.year, account);
            
            
        });
        
    }
    
    
}

function createFormPanel(formData, account){
	
	var editBool = true;
	
	var addButton = document.createElement("button");
	addButton.disabled = false;
	addButton.setAttribute("class", "w3tc-button-save button-primary");
	addButton.textContent = i18n.get("Add filed");
	
	var saveButton = document.createElement("button");
	saveButton.disabled = true;
	saveButton.setAttribute("class", "w3tc-button-save button-primary");
	saveButton.setAttribute("style", "float: right;");
	saveButton.textContent = i18n.get("Change ranking");
	
	var buttonPanel = document.createElement("div");
	buttonPanel.setAttribute("style", "padding-bottom: 10px;");
	buttonPanel.appendChild(addButton);
	buttonPanel.appendChild(saveButton);
	
	var formDataList = formData;
	console.log(formDataList);
	
	var mainPanel = document.getElementById("formPanel");
	mainPanel.textContent = null;
	mainPanel.appendChild(buttonPanel);
	var panel = document.createElement("div");
	panel.id = "formSort";
	panel.setAttribute("class", "dnd");
	
	var buttons = {};
	var columns = {};
	var list = {name: 'Name', email: 'Email', zip: 'Zip', D: 'D'};
	//for(var key in list){
	for(var key = 0; key < formDataList.length; key++){
		
		var contentPanel = document.createElement("div");
		contentPanel.setAttribute("class", "dnd_content");
		contentPanel.textContent = formDataList[key]['name'];
		
		if(formDataList[key]["active"] != "true"){
			
			contentPanel.classList.add("dnd_content_unactive");
			
		}
		
		var editLabel = document.createElement("label");
		editLabel.setAttribute("class", "dnd_edit");
		editLabel.setAttribute("data-key", key);
		editLabel.textContent = i18n.get("Edit");
		
		var deleteLabel = document.createElement("label");
		deleteLabel.setAttribute("class", "dnd_delete");
		deleteLabel.setAttribute("data-key", key);
		deleteLabel.textContent = i18n.get("Delete");
		
		var optionPanel = document.createElement("div");
		optionPanel.setAttribute("class", "dnd_optionBox");
		optionPanel.appendChild(editLabel);
		optionPanel.appendChild(deleteLabel);
		
		
		var column = document.createElement("div");
		column.setAttribute("class", "dnd_column");
		//column.setAttribute("draggable", "true");
		column.setAttribute("data-key", key);
		columns[key] = column;
		column.appendChild(contentPanel);
		column.appendChild(optionPanel);
		
		panel.appendChild(column);
		
		editLabel.onclick = function(event){
			
			if(editBool === true){
				
				editBool = false;
				var key = this.getAttribute("data-key");
				console.log(formDataList[key]);
				jQuery('#formSort').sortable('disable');
				editItem(columns, key, mainPanel, panel, 'updateForm', account, formDataList[key], schedule_data['formInputType'], function(action){
					
					editBool = true;
					if(action == 'cancel'){
						
						jQuery('#formSort').sortable('enable');
						
					}else{
						
						formData = action;
						createFormPanel(formData, account);
						
					}
					
				});
				
			}
			
			
			
		}
		
		deleteLabel.onclick = function(event){
			
			if(editBool === true){
				
				editBool = false;
				var dataKey = parseInt(this.getAttribute("data-key"));
				var result = confirm(i18n.get('Do you delete filed of "%s"?', [formDataList[dataKey].name]));
				if(result === true){
					
					deleteItem(dataKey, "deleteFormItem", account, function(json){
						
						formData = json;
						createFormPanel(formData, account);
						
					});
					
				}
				editBool = true;
				
			}
			
		}
		
	}
	
	mainPanel.appendChild(panel);
	
	jQuery('#formSort').sortable({
									cursor: 'move',
									opacity: 0.7,
									placeholder: "ui-state-highlight",
									forcePlaceholderSize: true,
									forceHelperSize: true,
									axis: 'y'
	});
	
	jQuery(document).off("sortstop", "#formSort");
	jQuery(document).on('sortstop', '#formSort', function(){
		
		var sortBool = sortData('name', 'dnd_column', formDataList, panel, 'changeFormRank');
		if(sortBool === true){
			
			saveButton.disabled = false;
			
		}else{
			
			saveButton.disabled = true;
			
		}
		
	});
	
	addButton.onclick = function(event){
		
		if(editBool === true){
			
			editBool = false;
			jQuery('#formSort').sortable('disable');
			addButton.disabled = true;
			addItem(mainPanel, 'addForm', account, schedule_data['formInputType'], function(action){
				
				editBool = true;
				if(action == "close"){
					
					jQuery('#formSort').sortable('enable');
					addButton.disabled = false;
					
				}else{
					
					console.log(typeof action);
					if(typeof action == 'object'){
						
						if(action['status'] != 'error'){
							
							console.log(action);
							formData = action;
							createFormPanel(formData, account);
							
						}
						
					}
					
				}
				
			});
			
		}
		
	}
	
	saveButton.onclick = function(event){
		
		formDataList = changeRank('name', 'dnd_column', formDataList, panel, 'changeFormRank', account, function(json){
			
			formData = json;
			saveButton.disabled = true;
			var panelList = panel.getElementsByClassName('dnd_column');
			for(var i = 0; i < panelList.length; i++){
				
				panelList[i].setAttribute("data-key", i);
				
			}
			
		});
		
		console.log(formDataList);
		
	}
	
	
}

var createCoursePanel = function(courseList, account){
	
	var editBool = true;
	
	var addButton = document.createElement("button");
	addButton.disabled = false;
	addButton.setAttribute("class", "w3tc-button-save button-primary");
	addButton.textContent = i18n.get("Add service");
	
	var saveButton = document.createElement("button");
	saveButton.disabled = true;
	saveButton.setAttribute("class", "w3tc-button-save button-primary");
	saveButton.setAttribute("style", "float: right;");
	saveButton.textContent = i18n.get("Change ranking");
	
	var buttonPanel = document.createElement("div");
	buttonPanel.setAttribute("style", "padding-bottom: 10px;");
	buttonPanel.appendChild(addButton);
	buttonPanel.appendChild(saveButton);
	
	var mainPanel = document.getElementById("coursePanel");
	mainPanel.textContent = null;
	mainPanel.appendChild(buttonPanel);
	
	var panel = document.createElement("div");
	panel.id = "courseSort";
	panel.setAttribute("class", "dnd");
	var buttons = {};
	var columns = {};
	var list = {name: 'Name', email: 'Email', zip: 'Zip', D: 'D', Test: 'Test', planA: 'plan A', area: 'area', G: 'G'};
	list = {};
	//var courseList = courseList;
	console.log(courseList);
	for(var i = 0; i < courseList.length; i++){
		
		list[courseList[i]['key']] = courseList[i]['name'];
		
	}
	console.log(list);
	//for(var key in courseList){
	for(var key = 0; key < courseList.length; key++){
		
		var contentPanel = document.createElement("div");
		contentPanel.setAttribute("class", "dnd_content");
		contentPanel.textContent = courseList[key]['name'];
		
		if(courseList[key]["active"] != "true"){
			
			contentPanel.classList.add("dnd_content_unactive");
			
		}
		
		var editLabel = document.createElement("label");
		editLabel.setAttribute("class", "dnd_edit");
		editLabel.setAttribute("data-key", key);
		editLabel.textContent = i18n.get("Edit");
		
		var deleteLabel = document.createElement("label");
		deleteLabel.setAttribute("class", "dnd_delete");
		deleteLabel.setAttribute("data-key", key);
		deleteLabel.textContent = i18n.get("Delete");
		
		var optionPanel = document.createElement("div");
		optionPanel.setAttribute("class", "dnd_optionBox");
		optionPanel.appendChild(editLabel);
		optionPanel.appendChild(deleteLabel);
		
		
		var column = document.createElement("div");
		column.setAttribute("class", "dnd_column");
		column.setAttribute("draggable", "true");
		column.setAttribute("data-key", key);
		column.appendChild(contentPanel);
		column.appendChild(optionPanel);
		columns[key] = column;
		
		panel.appendChild(column);
		
		editLabel.onclick = function(event){
			
			if(editBool === true){
				
				editBool = false;
				var key = this.getAttribute("data-key");
				editItem(columns, key, mainPanel, panel, 'updateCourse', account, courseList[key], schedule_data['courseData'], function(action){
					
					editBool = true;
					if(action == 'cancel'){
						
						
					}else{
						
						courseList = action;
						createCoursePanel(courseList, account);
						
					}
					
				});
				
			}
			
		}
		
		deleteLabel.onclick = function(event){
			
			if(editBool === true){
				
				editBool = false;
				var courseInfo = courseList[parseInt(this.getAttribute("data-key"))];
				//var result = confirm("Do you delete service of \"" + courseInfo.name + "\"?");
				var result = confirm(i18n.get('Do you delete service of "%s"?', [courseInfo.name]));
				if(result === true){
					
					console.log(courseInfo);
					deleteItem(courseInfo.key, "deleteCourse", account, function(json){
						
						courseList = json;
						createCoursePanel(courseList, account);
						
					});
					
				}
				editBool = true;
				
			}
			
		}
		
	}
	
	mainPanel.appendChild(panel);
	
	jQuery('#courseSort').sortable({
									cursor: 'move',                     //移動中のカーソル
									opacity: 0.7,                       //移動中の項目の透明度
									placeholder: "ui-state-highlight",  //ドロップ先の色指定(Styleで指定可能)
									forcePlaceholderSize: true,          //trueでドラッグした要素のサイズを自動取得できる
									forceHelperSize: true,
									axis: 'y'
	});
	
	//$( '#formSort' ).disableSelection();
	jQuery(document).off("sortstop", "#courseSort");
	jQuery(document).on('sortstop', '#courseSort', function(){
		
		var sortBool = sortData('key', 'dnd_column', courseList, panel, 'changeCourseRank');
		if(sortBool === true){
			
			saveButton.disabled = false;
			
		}else{
			
			saveButton.disabled = true;
			
		}
		
	});
	
	addButton.onclick = function(event){
		
		if(editBool === true){
			
			editBool = false;
			addButton.disabled = true;
			addItem(mainPanel, 'addCourse', account, schedule_data['courseData'], function(action){
				
				editBool = true;
				if(action == "close"){
					
					addButton.disabled = false;
					
				}else{
					
					console.log(typeof action);
					if(typeof action == 'object'){
						
						if(action['status'] != 'error'){
							
							console.log(action);
							courseList = action;
							createCoursePanel(courseList, account);
							
						}
						
					}
					
				}
				
			});
			
		}
		
		
	};
	
	saveButton.onclick = function(event){
		
		courseList = changeRank('key', 'dnd_column', courseList, panel, 'changeCourseRank', account, function(json){
			
			//setting_data['courseList'] = json;
			courseList = json;
			saveButton.disabled = true;
			var panelList = panel.getElementsByClassName('dnd_column');
			for(var i = 0; i < panelList.length; i++){
				
				panelList[i].setAttribute("data-key", i);
				
			}
			
		});
		
		console.log(courseList);
		
	}
	
}

var settingPanel = function(accountList, month, day, year, account, callback){
    
    var settingPanel = document.getElementById("settingPanel");
    settingPanel.textContent = null;
    
    var addPanel = document.createElement("div");
    settingPanel.appendChild(addPanel);
	addPanel.id = "addCoursePanel";
	
    var inputData = {};
    
    var inputTypeList = schedule_data['elementForCalendarAccount'];
    
    var table = document.createElement("table");
	table.setAttribute("class", "form-table");
	console.log(account);
	console.log(inputTypeList);
	var trList = {}
	for(var key in inputTypeList){
		
		console.log(key);
        var data = inputTypeList[key];
        data.value = account[key];
        
        var th = document.createElement("th");
        th.setAttribute("scope", "row");
        th.textContent = i18n.get(inputTypeList[key].name);
        
        var inputPanel = createInput(key, data, inputData, false);
        var td = document.createElement("td");
        td.appendChild(inputPanel);
        
        var tr = document.createElement("tr");
        tr.setAttribute("valign", "top");
        tr.appendChild(th);
        tr.appendChild(td);
        trList[key] = tr;
        table.appendChild(tr);
		
	}
	
	if(inputData.id && inputData.id.textBox){
		
		console.log(inputData.id);
		inputData.id.textBox.disabled = true;
		
	}
	
    addPanel.appendChild(table);
    
    var saveButton = document.createElement("button");
    saveButton.textContent = i18n.get("Save");
    saveButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var deleteButton = document.createElement("button");
    deleteButton.textContent = i18n.get("Delete");
    deleteButton.setAttribute("class", "media-button button-primary button-large media-button-insert deleteButton");
    
    var buttonPanel = document.createElement("div");
    buttonPanel.setAttribute("style", "text-align: right; margin: 10px 10px 10px 0px;");
    buttonPanel.appendChild(saveButton);
    buttonPanel.appendChild(deleteButton);
    addPanel.appendChild(buttonPanel);
    
    var confirm = new Confirm();
    
    saveButton.onclick = function(){
        
        var post = {nonce: nonce, action: action, mode: 'updateCalendarAccount', accountKey: account.key};
        var response = getInputData(inputTypeList, inputData);
        console.log(response);
        for(var key in response){
            
            if(typeof response[key] == 'boolean'){
    			
    			console.log("error key = " + key + " bool = " + response[key]);
    			trList[key].classList.add("errorPanel");
    			post = false;
    			break;
    			
    		}else{
    			
    			post[key] = response[key];
    			trList[key].classList.remove("errorPanel");
    			
    		}
            
        }
        
        if(post !== false){
            
            console.log(post);
            loadingPanel.setAttribute("class", "loading_modal_backdrop");
            xmlHttp = new Booking_App_XMLHttp(url, post, function(json){
                
                console.log(json);
                loadingPanel.setAttribute("class", "hidden_panel", 'getTemplateSchedule');
                if(json.status != null && parseInt(json.status) == 0){
                    
                    confirm.alertPanelShow(i18n.get("Error"), i18n.get("An unknown cause of error occurred"), false, function(callback){
                        
                    });
                    
                }else{
                    
                    callback(json);
                    
                }
                
            });
            
        }
        
    }
    
    deleteButton.onclick = function(){
        
        confirm.dialogPanelShow(i18n.get("Confirm to delete"), i18n.get('Do you delete the "%s" about this operation?', [account.name]), false, function(bool){
            
            console.log(bool);
            if(bool === true){
                
                loadingPanel.setAttribute("class", "loading_modal_backdrop");
                var post = {nonce: nonce, action: action, mode: 'deleteCalendarAccount', accountKey: account.key};
                
                xmlHttp = new Booking_App_XMLHttp(url, post, function(json){
                    
                    console.log(json);
                    loadingPanel.setAttribute("class", "hidden_panel", 'getTemplateSchedule');
                    document.getElementById("tabFrame").classList.add("hidden_panel");
	                createCalendarAccountList(json, month, day, year);
                    
                });
                
            }
            
        });
        
    }
    
}

var addItem = function(mainPanel, mode, account, inputTypeList, callback){
	
	console.log(mainPanel);
	
	var closeHeghit = mainPanel.clientHeight;
	var addPanel = document.createElement("div");
	addPanel.id = "addCoursePanel";
	mainPanel.appendChild(addPanel);
	
    for(var key in inputTypeList){
    	
    	inputTypeList[key]['value'] = "";
    	
    }
    
    console.log(inputTypeList);
    
    if(mode == 'addCourse'){
    	
    	var courseTimeList = {};
    	for(var i = 5; i < 1440; i += 5){
    		
    		courseTimeList[i] = i + "min";
    		
    	}
    	inputTypeList['time']['valueList'] = courseTimeList;
    	
    }else if(mode == 'addForm'){
    	
    	for(var key in inputTypeList){
    		
    		if(key == "required" || key == "isEmail" || key == "isName" || key == "isAddress"){
    			
    			inputTypeList[key]['value'] = "false";
    			
    		}else if(key == "type"){
    			
    			inputTypeList[key]['value'] = "TEXT";
    			
    		}
    		
    		
    	}
    	
    }else if(mode == 'addCalendarAccount'){
        
        inputTypeList.name.value = "New Calendar";
        inputTypeList.type.value = "day";
        inputTypeList.status.value = "open";
        inputTypeList.courseBool.value = 0;
        
    }
    
	console.log(inputTypeList);
	var inputData = {};
	var table = document.createElement("table");
	table.setAttribute("class", "form-table");
	var trList = {};
	for(var key in inputTypeList){
		
		console.log(key);
        var data = inputTypeList[key];
        
        var th = document.createElement("th");
        th.setAttribute("scope", "row");
        th.textContent = i18n.get(inputTypeList[key].name);
        
        var inputPanel = createInput(key, data, inputData, false);
        var td = document.createElement("td");
        td.appendChild(inputPanel);
        
        var tr = document.createElement("tr");
        tr.setAttribute("valign", "top");
        tr.appendChild(th);
        tr.appendChild(td);
        trList[key] = tr;
        table.appendChild(tr);
		
	}
    
    addPanel.appendChild(table);
    
    var cancelButton = document.createElement("button");
    cancelButton.setAttribute("style", "margin-right: 10px;");
    cancelButton.textContent = i18n.get("Cancel");
    cancelButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var saveButton = document.createElement("button");
    saveButton.textContent = i18n.get("Save");
    saveButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var buttonPanel = document.createElement("div");
    buttonPanel.setAttribute("style", "text-align: right; margin: 10px 10px 10px 0px;");
    buttonPanel.appendChild(cancelButton);
    buttonPanel.appendChild(saveButton);
    addPanel.appendChild(buttonPanel);
    
    
    //mainPanel.style.height = closeHeghit + addPanel.clientHeight + "px";
    
    console.log("top = " + addPanel.offsetTop);
    console.log("closeHeghit = " + closeHeghit);
	window.scrollTo(0, addPanel.offsetTop);
    
    cancelButton.onclick = function(event){
    	
    	mainPanel.removeChild(addPanel);
    	mainPanel.style.height = null;
    	console.log("cancelButton closeHeghit = " + closeHeghit);
    	callback("close");
    	
    }
    
    saveButton.onclick = function(event){
    	
    	var response = null;
    	
    	var postData = {mode: mode, nonce: nonce, action: action};
    	if(account != null){
    	    
    	    postData.accountKey = account.key;
    	    
    	}
    	
    	if(mode == 'addCourse'){
    		/**
    		var selected = inputData['time']['selectBox'].selectedIndex + 1;
    		postData['name'] = inputData['name']['textBox'].value;
    		postData['time'] = selected * 5;
    		**/
    		console.log("rank = " + (document.getElementById("courseSort").childNodes.length + 1));
    		postData['rank'] = document.getElementById("courseSort").childNodes.length + 1;
    		
    		response = getInputData(inputTypeList, inputData);
    		
    	}else if(mode == 'addForm'){
    		
    		response = getInputData(inputTypeList, inputData);
    		
    	}else if(mode == 'addCalendarAccount'){
    	    
    	    response = getInputData(inputTypeList, inputData);
    	    
    	}
    	
    	var post = true;
    	for(var key in response){
    			
    		if(typeof response[key] == 'boolean'){
    			
    			console.log("error key = " + key + " bool = " + response[key]);
    			trList[key].classList.add("errorPanel");
    			post = false;
    			
    		}else{
    			
    			postData[key] = response[key];
    			trList[key].classList.remove("errorPanel");
    			
    		}
    		
    	}
    	
    	if(post === true){
    		
    		console.log(postData);
    		loadingPanel.setAttribute("class", "loading_modal_backdrop");
    		xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
				
				if(json['status'] != 'error'){
					
					mainPanel.removeChild(addPanel);
    				mainPanel.style.height = null;
					console.log(json);
					callback(json);
					
				}else{
					
					alert(json["message"]);
					
				}
				loadingPanel.setAttribute("class", "hidden_panel");
								
			});
    		
    	}
    	
		
    }
	
}

var editItem = function(columns, editKey, mainPanel, columnsPanel, mode, account, itemData, inputTypeList, callback){
	
	console.log("editKey = " + editKey);
	
	console.log(columns[editKey]);
	console.log(itemData);
	
	var addPanel = document.createElement("div");
	addPanel.id = "addCoursePanel";
	
    var inputData = {};
    if(mode == 'updateCourse'){
    	
    	inputTypeList["name"]["value"] = itemData["name"];
    	inputTypeList["active"]["value"] = itemData["active"];
    	if(itemData["cost"] != null){
    		
    		//inputTypeList["cost"]["value"] = parseFloat(itemData["cost"]);
    		inputTypeList["cost"]["value"] = parseInt(itemData["cost"]);
    		
    	}
    	inputTypeList["time"]["value"] = parseInt(itemData["time"]);
    	var courseTimeList = {};
    	for(var i = 5; i < 1440; i += 5){
    	
    		courseTimeList[i] = i + "min";
    	
		}
    	inputTypeList['time']['valueList'] = courseTimeList;
    	
    }else if(mode == 'updateForm'){
    	
    	inputTypeList["id"]["value"] = itemData["id"];
    	inputTypeList["name"]["value"] = itemData["name"];
    	inputTypeList["type"]["value"] = itemData["type"];
    	inputTypeList["active"]["value"] = itemData["active"];
    	inputTypeList["required"]["value"] = itemData["required"];
    	inputTypeList["isName"]["value"] = itemData["isName"];
    	inputTypeList["isAddress"]["value"] = itemData["isAddress"];
    	inputTypeList["isEmail"]["value"] = itemData["isEmail"];
    	inputTypeList["options"]["value"] = itemData["options"];
    	
    }
    
    var index = 0;
	console.log(inputTypeList);
	
	var table = document.createElement("table");
	table.setAttribute("class", "form-table");
	
	var trList = {}
	for(var key in inputTypeList){
		
		console.log(key);
        var data = inputTypeList[key];
        
        var th = document.createElement("th");
        th.setAttribute("scope", "row");
        th.textContent = i18n.get(inputTypeList[key].name);
        
        var inputPanel = createInput(key, data, inputData, false);
        var td = document.createElement("td");
        td.appendChild(inputPanel);
        
        var tr = document.createElement("tr");
        tr.setAttribute("valign", "top");
        tr.appendChild(th);
        tr.appendChild(td);
        trList[key] = tr;
        table.appendChild(tr);
		
	}
	
	if(inputData.id && inputData.id.textBox){
		
		console.log(inputData.id);
		inputData.id.textBox.disabled = true;
		
	}
	
    addPanel.appendChild(table);
    
    var cancelButton = document.createElement("button");
    cancelButton.setAttribute("style", "margin-right: 10px;");
    cancelButton.textContent = i18n.get("Cancel");
    cancelButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var saveButton = document.createElement("button");
    saveButton.textContent = i18n.get("Save");
    saveButton.setAttribute("class", "w3tc-button-save button-primary");
    
    var buttonPanel = document.createElement("div");
    buttonPanel.setAttribute("style", "text-align: right; margin: 10px 10px 10px 0px;");
    buttonPanel.appendChild(cancelButton);
    buttonPanel.appendChild(saveButton);
    addPanel.appendChild(buttonPanel);
    
    console.log("addPanel Height = " + addPanel.clientHeight);
    
    var plusHeight = addPanel.clientHeight - columns[editKey].clientHeight;
    var height = addPanel.clientHeight;
    
    console.log(columns[editKey]);
    columns[editKey].setAttribute("class", "hidden_panel");
    columnsPanel.insertBefore(addPanel, columns[editKey]);
    
    
    var index = 0;
	for(var key in columns){
		
		if(key == editKey){
			
			break;
		}
		
	}
    
	console.log(columns);
	console.log("height = " + height);
	columnsPanel.style.height = height + "px";
    
    cancelButton.onclick = function(event){
    	
    	columnsPanel.removeChild(addPanel);
    	columns[key].setAttribute("class", "dnd_column ui-sortable-handle");
    	callback('cancel');
    	
    }
    
    saveButton.onclick = function(event){
    	
    	var response = null;
    	var postData = {mode: mode, nonce: nonce, action: action};
    	if(account != null){
    	    
    	    postData.accountKey = account.key;
    	    
    	}
    	
    	if(mode == 'updateCourse'){
    		
    		console.log(inputData);
    		postData['key'] = itemData['key'];
    		response = getInputData(inputTypeList, inputData);
			
    	}else if(mode == 'updateForm'){
    		
    		postData['key'] = editKey;
    		response = getInputData(inputTypeList, inputData);
    		response.id = itemData.id;
    		
    	}
    	
    	var post = true;
    	for(var key in response){
    			
    		if(typeof response[key] == 'boolean'){
    			
    			console.log("error key = " + key + " bool = " + response[key]);
    			trList[key].classList.add("errorPanel");
    			post = false;
    			
    		}else{
    			
    			postData[key] = response[key];
    			trList[key].classList.remove("errorPanel");
    			
    		}
    		
    	}
    	
    	if(post === true){
    		
    		loadingPanel.setAttribute("class", "loading_modal_backdrop");
    		console.log(itemData);
    		console.log(postData);
    		xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
				
				if(json['status'] != 'error'){
					
					//mainPanel.removeChild(addPanel);
    				mainPanel.style.height = null;
					console.log(json);
					callback(json);
					loadingPanel.setAttribute("class", "hidden_panel");
					
				}else{
					
					alert(json["message"]);
					
				}
									
			});
    		
    	}
    	
    }
	
}

var deleteItem = function(key, mode, account, callback){
	
	loadingPanel.setAttribute("class", "loading_modal_backdrop");
	var postData = {mode: mode, nonce: nonce, action: action, key: key, accountKey: account.key};
    xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
		
		if(json['status'] != 'error'){
			
			callback(json);
			
		}
		loadingPanel.setAttribute("class", "hidden_panel");
								
	});
	
}

var sortData = function(key, className, list, panel, mode){
	
	console.log(list);
	var sortBool = false;
	var panelList = panel.getElementsByClassName(className);
	for(var i = 0; i < list.length; i++){
		
		var index = parseInt(panelList[i].getAttribute("data-key"));
		if(i != index){
			
			sortBool = true;
			break;
			
		}
		
	}
	
	var keyList = [];
	var indexList = [];
	if(sortBool === true){
		
		for(var i = 0; i < panelList.length; i++){
			
			keyList.push(list[i][key]);
			var index = parseInt(panelList[i].getAttribute("data-key"));
			indexList.push(index);
			console.log(panelList[i]);
			
		}
		
	}
	
	console.log(keyList);
	console.log(indexList);
	return sortBool;
	
}

var changeRank = function(key, className, list, panel, mode, account, callback){
	
	loadingPanel.setAttribute("class", "loading_modal_backdrop");
	var newList = [];
	var keyList = [];
	var indexList = [];
	
	var panelList = panel.getElementsByClassName(className);
	for(var i = 0; i < panelList.length; i++){
		
		
		var panelKey = parseInt(panelList[i].getAttribute("data-key"));
		newList.push(list[panelKey]);
		keyList.push(list[panelKey][key]);
		
		indexList.push(i);
		console.log(panelList[i]);
		
	}
	
	
	var postData = {mode: mode, nonce: nonce, action: action, keyList: keyList.join(","), indexList: indexList.join(","), accountKey: account.key};
	xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
		
		callback(json);
		loadingPanel.setAttribute("class", "hidden_panel");
			
	});
	
	return newList;
	
}


function emailSettingPanel(emailMessageList, formData, account){
	
	//var emailMessageList = setting_data['emailMessageList'];
	console.log(emailMessageList);
	var mailSettingPanel = document.getElementById("mailSettingPanel");
	var content_area = document.getElementById("content_area");
	content_area.textContent = null;
	
	var table = document.createElement("table");
	table.setAttribute("class", "emails_table table_option wp-list-table widefat fixed striped")
	content_area.appendChild(table);
	
	var mail_message = {mailAdmin: "mail_new_admin",/**mailVisitor: "mail_new_visitor",**/ mailApproved: "mail_approved", mailPending: "mail_pending", mailDeleted: "mail_deleted"};
	var valueTdList = {};
	for(var id in mail_message){
		
		var mailMessageData = emailMessageList[mail_message[id]];
		console.log(mailMessageData);
		
		var nameTh = document.createElement("th");
		nameTh.textContent = i18n.get(mailMessageData.title);
		if(parseInt(mailMessageData.enable) === 0){
			
			nameTh.classList.add("disableTh");
			
		}
		
		var subjectLabel = document.createElement("div");
		subjectLabel.setAttribute("class", "subjectLabel");
		subjectLabel.innerHTML = "<strong>" + i18n.get("Subject") + "</strong><br>" + mailMessageData.subject;
		
		var content = mailMessageData.content.replace(/\\/g, "");
		var contentLabel = document.createElement("div");
		contentLabel.innerHTML = "<strong>" + i18n.get("Content") + "</strong><br>" + content;
		
		var valueTd = document.createElement("td");
		valueTd.appendChild(subjectLabel);
		valueTd.appendChild(contentLabel);
		//valueTd.innerHTML = mailMessageData.content.replace(/\\/g, "");
		
		var editButton = document.createElement("button");
		editButton.id = id;
		editButton.setAttribute("class", "w3tc-button-save button-primary");
		editButton.textContent = i18n.get("Edit");
		
		var editButtonTd = document.createElement("td");
		editButtonTd.setAttribute("class", "editButtonTd");
		editButtonTd.appendChild(editButton);
		
		var tr = document.createElement("tr");
		tr.appendChild(nameTh);
		tr.appendChild(valueTd);
		tr.appendChild(editButtonTd);
		
		table.appendChild(tr);
		valueTdList[id] = valueTd;
		
		editButton.onclick = function(){
			
			var id = mail_message[this.id];
			
			var editer_id = "textarea";
			var mailMessageData = emailMessageList[id];
			console.log("id = " + id);
			console.log(mailMessageData);
			
			var emailEdit = document.getElementById("email_edit_panel");
			emailEdit.classList.remove("hidden_panel");
			var media_frame_content = document.getElementById("media_frame_content");
			media_frame_content.textContent = null;
			document.getElementById("media_title").classList.add("media_left_zero");
			document.getElementById("media_router").classList.add("hidden_panel");
			document.getElementById("menu_panel").classList.add("hidden_panel");
			//media_frame_content.appendChild(emailEdit);
			
			document.getElementById("edit_title").textContent = mailMessageData.title;
			
			var enableCheck = document.getElementById("mailEnable");
			enableCheck.checked = false;
			if(parseInt(mailMessageData.enable) == 1){
				
				enableCheck.checked = true;
				
			}
			
			document.getElementById("emailFormatHtml").checked = true;
			if(mailMessageData.format == "text"){
				
				document.getElementById("emailFormatText").checked = true;
				
			}
			
			var subject_filed = document.getElementById("subject");
			subject_filed.setAttribute("placeholder", "Enter subject here");
			subject_filed.value = mailMessageData.subject;
			
			var mail_message_area_left = document.getElementById("mail_message_area_left");
			
			var contentId = "emailContent";
			document.getElementById(contentId).value = mailMessageData.content;
    		//console.log(value);
    		
    		
    		if(tinymce.get(contentId) != null /** && tinymce.get(contentId).getContent() != null**/){
    			
    			tinymce.get(contentId).setContent(mailMessageData.content);
    			//value = tinymce.get(id).save();
    			//console.log(tinymce.get(id).save());
    			
    		}
			
			
			/**
			for(var key in mail_message){
				
				var content_id = mail_message[key];
				var content_panel = document.getElementById(content_id + "_panel");
				if(id == content_id){
					
					content_panel.classList.remove("hidden_panel");
					
				}else{
					
					content_panel.classList.add("hidden_panel");
					
				}
				
			}
			**/
			
			var mail_message_area_right = document.getElementById("mail_message_area_right");
			mail_message_area_right.textContent = null;
			
			var mail_message_area_right_title = document.createElement("div");
			mail_message_area_right_title.setAttribute("class", "mail_message_area_right_title");
			mail_message_area_right_title.textContent = i18n.get("Help");
			mail_message_area_right.appendChild(mail_message_area_right_title);
			
			var str = i18n.get("You can use following shortcodes in content editer.");
			var help_message_label = document.createElement("div");
			help_message_label.setAttribute("class", "help_message_label");
			help_message_label.textContent = str;
			mail_message_area_right.appendChild(help_message_label);
			
			var shortcodes = {id: "Booking ID", date: "Booking date", site_name: "Your site name", service: "Service"};
			for(var key in shortcodes){
				
				var formFiledPanel = document.createElement("div");
				formFiledPanel.setAttribute("class", "formFiledPanel");
				mail_message_area_right.appendChild(formFiledPanel);
				
				var codeLabel = document.createElement("div");
				codeLabel.innerHTML = "[" + key + "] is inserting \"" + shortcodes[key] + "\"";
				formFiledPanel.appendChild(codeLabel);
				
			}
			
			//var formData = setting_data.formData;
			for(var i = 0; i < formData.length; i++){
				
				var filedData = formData[i];
				if(filedData.active != 'true'){
					
					continue;
					
				}
				
				var formFiledPanel = document.createElement("div");
				formFiledPanel.setAttribute("class", "formFiledPanel");
				mail_message_area_right.appendChild(formFiledPanel);
				
				var codeLabel = document.createElement("div");
				codeLabel.innerHTML = "[" + filedData.id + "] is inserting \"" + filedData.name + "\"";
				formFiledPanel.appendChild(codeLabel);
				
				
			}
			
			
			var editPanel = document.getElementById("editPanel");
			
			
			
			console.log(tinymce);
			console.log(tinyMCEPreInit.mceInit);
			
			var mail_message_save_button = document.createElement("button");
			mail_message_save_button.setAttribute("class", "button media-button button-primary button-large media-button-insert");
			mail_message_save_button.textContent = i18n.get("Save");
			
			var buttonPanel = document.getElementById("buttonPanel");
			buttonPanel.appendChild(mail_message_save_button);
			
			editPanelShow(true);
			//document.getElementById("mail_message_save_button").removeEventListener("click", event);
			mail_message_save_button.onclick = function(){
				
				var value = document.getElementById(contentId).value;
    			console.log(value);
    			
    			if(tinymce.get(contentId) != null && tinymce.get(contentId).getContent() != null){
    				
    				value = tinymce.get(contentId).save();
    				console.log(tinymce.get(contentId).save());
    				
    			}
    			
    			var enable = 0;
    			if(enableCheck.checked === true){
    				
    				enable = 1;
    				
    			}
    			
    			var format = "html";
    			if(document.getElementById("emailFormatText").checked === true){
    				
    				format = "text";
    				
    			}
    			
    			loadingPanel.setAttribute("class", "loading_modal_backdrop");
    			var postData = {mode: "updataEmailMessageForCalendarAccount", nonce: nonce, action: action, mail_id: mailMessageData.key, subject: subject_filed.value, content: value, enable: enable, format: format, accountKey: account.key};
    			console.log(postData);
    			xmlHttp = new Booking_App_XMLHttp(url, postData, function(json){
					
					emailSettingPanel(json.emailMessageList, json.formData, account);
					loadingPanel.setAttribute("class", "hidden_panel");
					
				});
				
			}
			
			
		}
		
		
	}
	
	
	
}


var getInputData = function(inputTypeList, inputData){
	
	var postData = {};
	for(var key in inputTypeList){
    	
    	console.log(key);
    	var values = [];
    	var inputType = inputTypeList[key];
    	console.log(inputType);
    	for(var inputKey in inputData[key]){
    		
    		var bool = true;
    		if(inputType['inputType'] == 'TEXT' || inputType['inputType'] == 'TEXTAREA'){
    			
    			if(inputData[key][inputKey].value.length == 0 && inputType.inputLimit == '1'){
    				
    				bool = false;
    				
    			}else{
    				
    				values.push(inputData[key][inputKey].value);
    				
    			}
    			
    		}else if(inputType['inputType'] == 'CHECK' || inputType['inputType'] == 'RADIO'){
    			
    			if(inputData[key][inputKey].checked == true){
    				
    				values.push(inputData[key][inputKey].getAttribute("data-value"));
    				
    			}
    			
    		}else if(inputType['inputType'] == 'OPTION'){
    			
    			if(inputData[key][inputKey].checked == true){
    				
    				values.push(inputData[key][inputKey].value);
    				
    			}
    			
    		}else if(inputType['inputType'] == 'SELECT'){
    			
    			var index = inputData[key][inputKey].selectedIndex;
    			values.push(inputData[key][inputKey].options[index].value);
    			
    		}
    		
    	}
    	
    	if(bool === true){
    		
    		postData[key] = values.join(",");
    		
    	}else{
    		
    		postData[key] = false;
    		
    	}
    	
    	//postData[key] = false;
    	console.log(inputData[key]);
    	
    }
	
	return postData;
	
}

var createInput = function(inputName, input, inputData, disabled){
	
	console.log("createInput");
	console.log(input);
	var list = null;
	if(input['valueList'] != null){
	    
	    list = input['valueList'];
	    
	}
	
	console.log(list);
	var valuePanel = document.createElement("div");
	if(input['inputType'] == 'TEXT'){
		
		var textBox = document.createElement("input");
		textBox.setAttribute("class", "regular-text");
		textBox.type = "text";
		textBox.value = input['value'];
		textBox.disabled = disabled;
		
		valuePanel.appendChild(textBox);
		inputData[inputName] = {textBox: textBox};
		
	}else if(input['inputType'] == 'SELECT'){
		
		var selectBox = document.createElement("select");
		selectBox.disabled = disabled;
		//for(var i = 0; i < list.length; i++){
		console.log(typeof list);
		console.log(list);
		for(var key in list){
			
			var optionBox = document.createElement("option");
			optionBox.value = key;
			optionBox.textContent = list[key];
			
			console.log("key = " + key + " content = " + list[key]);
			if(key == input['value']){
				
				console.log("value = " + input['value']);
				optionBox.selected = true;
				
			}
			
			selectBox.appendChild(optionBox);
			
			
		}
		
		valuePanel.appendChild(selectBox);
		inputData[inputName] = {selectBox: selectBox};
		
	}else if(input['inputType'] == 'SELECT_GROUP'){
		
		var selectBox = document.createElement("select");
		selectBox.disabled = disabled;
		//for(var i = 0; i < list.length; i++){
		console.log(typeof list);
		console.log(list);
		
		var selectedvalue = null;
		for(var key in list){
			
			if(list[key]['alpha-2'] == input['value']){
				
				selectedvalue = key;
				break;
				
			}
			
		}
		
		if(selectedvalue == null){
			
			selectedvalue = "United States of America";
			
		}
		
		var selectedCountry = list[selectedvalue];
		console.log(selectedCountry)
		
		var optionBox = document.createElement("option");
		optionBox.value = selectedCountry['alpha-2'];
		optionBox.textContent = selectedCountry.name;
		
		var optgroup = document.createElement("optgroup");
		optgroup.setAttribute("label", i18n.get("Selected country"));
		optgroup.appendChild(optionBox);
		selectBox.appendChild(optgroup);
		
		var frequently = ["Canada", "France", "Germany", "Italy", "Japan", "United Kingdom of Great Britain and Northern Ireland", "United States of America"];
		
		var optgroup = document.createElement("optgroup");
		optgroup.setAttribute("label", i18n.get("Frequently used countries"));
		selectBox.appendChild(optgroup);
		
		console.log("selectedvalue = " + selectedvalue);
		for(var i = 0; i < frequently.length; i++){
			
			var key = frequently[i];
			if(list[key].name != selectedvalue){
				
				var optionBox = document.createElement("option");
				optionBox.value = list[key]['alpha-2'];
				optionBox.textContent = list[key].name;
				optgroup.appendChild(optionBox);
				
			}
			
		}
		
		var optgroup = document.createElement("optgroup");
		optgroup.setAttribute("label", i18n.get("Other countries"));
		selectBox.appendChild(optgroup);
		
		for(var key in list){
			
			var optionBox = document.createElement("option");
			optionBox.value = list[key]['alpha-2'];
			optionBox.textContent = list[key].name;
			
			//console.log("key = " + key + " content = " + list[key]);
			if(key == input['value']){
				
				console.log("value = " + input['value']);
				optionBox.selected = true;
				
			}
			
			optgroup.appendChild(optionBox);
			
			
		}
		
		valuePanel.appendChild(selectBox);
		inputData[inputName] = {selectBox: selectBox};
		
	}else if(input['inputType'] == 'OPTION'){
		
		console.log("inputType = " + input['inputType']);
		console.log(input);
		var options = [];
		if(input['value'] != null){
			
			options = input['value'].split(",");
			
		}
		
		console.log(options);
		var addButton = document.createElement("label");
		//addButton.setAttribute("class", "w3tc-button-save button-primary");
		addButton.setAttribute("class", "addLink");
		addButton.textContent = i18n.get("Add");
		valuePanel.appendChild(addButton);
		
		var table = document.createElement("table");
		table.setAttribute("class", "table_option wp-list-table widefat fixed striped");
		valuePanel.appendChild(table);
		
		inputData[inputName] = {};
		var tr_index = 0;
		var table_tr = {};
		
		for(var i = 0; i < options.length; i++){
			
			create_tr(tr_index, table, options[i]);
			tr_index++;
			
		}
		
		addButton.onclick = function(){
			
			create_tr(tr_index, table, null);
			tr_index++;
			
		}
		
		
		
		
	}else if(input['inputType'] == 'CHECK'){
		
		inputData[inputName] = {};
		for(var key in list){
			
			console.log("key = " + key + " value = " + list[key])
			var valueName = document.createElement("span");
			valueName.setAttribute("class", "radio_title");
			valueName.textContent = i18n.get(list[key]);
			
			var checkBox = document.createElement("input");
			checkBox.disabled = disabled;
			checkBox.setAttribute("data-value", key);
			checkBox.name = inputName;
			checkBox.type = "checkbox";
			checkBox.value = list[key];
			if(input['value'] == key){
				
				checkBox.checked = "checked";
				
			}
			
			var label = document.createElement("label");
			label.appendChild(checkBox);
			label.appendChild(valueName);
			valuePanel.appendChild(label);
			inputData[inputName][key] = checkBox;
			
		}
		
	}else if(input['inputType'] == 'RADIO'){
		
		inputData[inputName] = {};
		//for(var i = 0; i < list.length; i++){
	    for(var key in list){
			
			console.log(key + " = " + list[key]);
			var valueName = document.createElement("span");
			valueName.setAttribute("class", "radio_title");
			valueName.textContent = i18n.get(list[key]);
			
			var radioBox = document.createElement("input");
			radioBox.disabled = disabled;
			radioBox.setAttribute("data-value", key);
			radioBox.name = inputName;
			radioBox.type = "radio";
			radioBox.value = list[key];
			if(input['value'] == key){
				
				console.log("value = " + input['value']);
				radioBox.checked = "checked";
				
			}
			
			var label = document.createElement("label");
			label.appendChild(radioBox);
			label.appendChild(valueName);
			valuePanel.appendChild(label);
			inputData[inputName][key] = radioBox;
			
		}
		
	}else if(input['inputType'] == 'TEXTAREA'){
		
		var textareaBox = document.createElement("textarea");
		textareaBox.value = input['value'];
		textareaBox.disabled = disabled;
		valuePanel.appendChild(textareaBox);
		inputData[inputName] = {textBox: textareaBox};
		
	}
	
	function create_tr(tr_index, table, value){
			
		var textBox = document.createElement("input");
		textBox.setAttribute("data-key", tr_index);
		textBox.setAttribute("class", "regular-text");
		textBox.setAttribute("style", "width: 100%");
		textBox.type = "text";
		
		var filedTd = document.createElement("td");
		filedTd.setAttribute("class", "td_option");
		filedTd.appendChild(textBox);
		
		var deleteButton = document.createElement("label");
		deleteButton.setAttribute("data-key", tr_index);
		deleteButton.setAttribute("class", "deleteLink");
		
		var deleteTd = document.createElement("td");
		deleteTd.setAttribute("class", "td_delete td_option");
		deleteTd.appendChild(deleteButton);
		
		var tr = document.createElement("tr");
		tr.setAttribute("class", "tr_option");
		tr.appendChild(filedTd);
		tr.appendChild(deleteTd);
		
		table_tr[tr_index] = tr;
		table.appendChild(tr);
		
		var checkBox = document.createElement("input");
		checkBox.setAttribute("data-value", tr_index);
		checkBox.name = tr_index;
		checkBox.type = "checkbox";
		checkBox.value = null;
		inputData[inputName][tr_index] = checkBox;
		
		if(value != null && value.length != 0){
			textBox.value = value;
			checkBox.value = value;
			checkBox.checked = true;
		}
		
		textBox.onchange = function(){
			
			var dataKey = this.getAttribute("data-key");
			var value = this.value;
			var bool = false;
			if(value.length != 0){
				bool = true;
			}else{
				value = null;
			}
			
			inputData[inputName][dataKey].value = value;
			inputData[inputName][dataKey].checked = bool;
			console.log("dataKey = " + dataKey + " value = " + value + " bool = " + bool);
			
		}
		
		deleteButton.onclick = function(){
			
			var result = false;
			var dataKey = this.getAttribute("data-key");
			var length = inputData[inputName][dataKey].value.length;
			if(length == 0){
				
				result = true;
				
			}
			
			if(result === false){
				
				//result = confirm("Do you delete option of \"" + inputData[inputName][dataKey].value + "\"?");
				result = confirm(i18n.get("Do you delete option of \"%s\"?", [inputData[inputName][dataKey].value]));
				
			}
			
			if(result === true){
				
				var tr = table_tr[parseInt(dataKey)];
				table.removeChild(tr);
				delete table_tr[dataKey];
				delete inputData[inputName][dataKey];
				console.log(tr);
				console.log(table_tr);
				console.log(inputData[inputName]);
				console.log("tr_index = " + tr_index);
				
			}
			
		}
			
	}
	
	return valuePanel;
	
}

var editPanelShow = function(showBool){
    
    var body = document.getElementsByTagName("body")[0];
    console.log(body);
    if(showBool == true){
        
        body.classList.add("modal-open");
        editPanel.setAttribute("class", "edit_modal");
        blockPanel.setAttribute("class", "edit_modal_backdrop");
        
    }else{
        
        body.classList.remove("modal-open");
        editPanel.setAttribute("class", "hidden_panel");
        blockPanel.setAttribute("class", "hidden_panel");
        
    }
    
    
}