<?php
    
    if(!defined('ABSPATH')){
    	exit;
	}
    
    class Database {
        
        public $prefix = null;
        
        public $db_version = null;
        
        public $db_list = array();
        
        
        
        public function __construct($prefix, $db_version){
            
            $this->prefix = $prefix;
            $this->db_version = $db_version;
            
            global $wpdb;
			global $jal_db_version;
            $charset_collate = $wpdb->get_charset_collate();
            
            $table_name = $wpdb->prefix.'booking_package_calendarAccount';
			$this->db_list[$table_name] = "CREATE TABLE ".$table_name." (
					                    	`key`				INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT,
				                        	`name`				VARCHAR(255) NOT NULL, 
				                        	`type`				VARCHAR(50) DEFAULT 'day', 
				                        	`status`			VARCHAR(50) DEFAULT NULL, 
				                        	`courseTitle`		VARCHAR(255) DEFAULT NULL, 
				                        	`courseBool`		INT(1) DEFAULT 0, 
				                        	`created`			INT(11) DEFAULT NULL, 
				                        	`googleCalendarID`	VARCHAR(255) DEFAULT NULL, 
				                        	`uploadDate`		INT(11) DEFAULT NULL, 
				                        	UNIQUE KEY id (`key`)
				                        	) $charset_collate;";
			
			$table_name = $wpdb->prefix.'booking_package_templateSchedule';
			$this->db_list[$table_name] = "CREATE TABLE ".$table_name." (
					                       `key`			INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT, 
					                        `accountKey`	INT(11) NOT NULL, 
				                        	`weekKey`		INT(11) NOT NULL, 
				                          	`hour`			INT(11) NOT NULL,
				                          	`min`			INT(11) NOT NULL, 
				                        	`title`			VARCHAR(255) DEFAULT NULL, 
				                        	`cost`			INT DEFAULT NULL, 
				                        	`capacity`		INT(11) NOT NULL, 
				                        	`stop`			VARCHAR(255) DEFAULT NULL, 
				                        	`holiday`		VARCHAR(255) DEFAULT NULL, 
				                        	`uploadDate`	INT(11) DEFAULT NULL, 
				                        	UNIQUE KEY id (`key`)
				                        	) $charset_collate;";
				                	
			$table_name = $wpdb->prefix.'booking_package_schedule';
			$this->db_list[$table_name] = "CREATE TABLE ".$table_name." (
			                	        	`key`			    INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT, 
			                	        	`accountKey`        INT(11) NOT NULL, 
	                        	        	`unixTime`	    	INT(11) NOT NULL, 
			                	        	`year`		        INT(11) NOT NULL, 
				                        	`month`		        INT(11) NOT NULL, 
			                	        	`day`		        INT(11) NOT NULL, 
				                        	`weekKey`		    INT(11) NOT NULL, 
			                	        	`hour`			    INT(11) NOT NULL,
			                	        	`min`			    INT(11) NOT NULL, 
			                	        	`title`			    VARCHAR(255) DEFAULT NULL, 
			                	        	`cost`			    FLOAT DEFAULT NULL, 
				                        	`capacity`		    INT(11) NOT NULL, 
				                        	`remainder`		    INT(11) NOT NULL, 
				                        	`waitingRemainder`	INT(11) NOT NULL DEFAULT 0, 
				                        	`stop`			    VARCHAR(255) DEFAULT NULL, 
			                	        	`holiday`		    VARCHAR(255) DEFAULT NULL, 
				                        	`uploadDate`	    INT(11) DEFAULT NULL, 
			                   	        	UNIQUE KEY id (`key`)
		                		        	) $charset_collate;";
		                		        	
			$table_name = $wpdb->prefix.'booking_package_courseData';
			$this->db_list[$table_name] = "CREATE TABLE ".$table_name." (
			                	        	`key`			    INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT, 
			                	        	`accountKey`        INT(11) NOT NULL, 
			                	        	`name`			    VARCHAR(255) DEFAULT NULL, 
			                	        	`time`			    INT(11) DEFAULT NULL, 
			                	        	`cost`			    FLOAT DEFAULT NULL, 
			                	        	`active`		    VARCHAR(255) DEFAULT NULL, 
				                        	`ranking`		    INT(11) NOT NULL, 
			                   	        	UNIQUE KEY id (`key`)
		                		        	) $charset_collate;";
		                		        	
			$table_name = $wpdb->prefix.'booking_package_form';
			$this->db_list[$table_name] = "CREATE TABLE ".$table_name." (
			                	        	`key`			    INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT, 
			                	        	`accountKey`        INT(11) NOT NULL, 
			                	        	`data`			    TEXT DEFAULT NULL, 
			                   	        	UNIQUE KEY id (`key`)
		                		        	) $charset_collate;";
		                		        	
			$table_name = $wpdb->prefix.'booking_package_emailSetting';
			$this->db_list[$table_name] = "CREATE TABLE ".$table_name." (
			                	        	`key`			    INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT, 
			                	        	`accountKey`        INT(11) NOT NULL, 
			                	        	`mail_id`			VARCHAR(255) NOT NULL, 
			                	        	`enable`			INT(1) DEFAULT 1, 
			                	        	`format`			VARCHAR(255) DEFAULT 'text', 
			                	        	`subject`			VARCHAR(255) DEFAULT NULL, 
			                	        	`content`			TEXT DEFAULT NULL, 
			                	        	`data`			    TEXT DEFAULT NULL, 
			                   	        	UNIQUE KEY id (`key`)
		                		        	) $charset_collate;";
		                		        	
			$table_name = $wpdb->prefix.'booking_package_userPraivateData';
			$this->db_list[$table_name] = "CREATE TABLE ".$table_name." (
			                	        	`key`							INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT, 
			                	        	`reserveTime`					INT(11) NOT NULL, 
			                	        	`remainderTime`					INT(11) NULL, 
			                	        	`remainderBool`					VARCHAR(255) DEFAULT 'false', 
			                	        	`maintenanceTime`				INT(11) DEFAULT 0, 
			                	        	`permission`					VARCHAR(255) DEFAULT 'private', 
			                	        	`status`						VARCHAR(255) DEFAULT NULL, 
			                	        	`accountKey`					INT(11) NOT NULL, 
			                	        	`accountName`					VARCHAR(255) DEFAULT NULL, 
			                	        	`accountCost`					INT(11) DEFAULT NULL, 
			                	        	`scheduleUnixTime`				INT(11) DEFAULT 0, 
			                	        	`scheduleWeek`					INT(11) DEFAULT 0, 
			                	        	`scheduleTitle`					VARCHAR(255) DEFAULT NULL, 
			                	        	`scheduleCost`					INT(11) DEFAULT NULL, 
			                	        	`scheduleKey`					INT(11) DEFAULT NULL, 
			                	        	`applicantCount`				INT(11) DEFAULT 1, 
			                	        	`courseKey`						VARCHAR(255) DEFAULT NULL, 
			                	        	`courseTitle`					VARCHAR(255) DEFAULT NULL, 
			                	        	`courseName`					VARCHAR(255) DEFAULT NULL, 
			                	        	`courseTime`					INT(11) DEFAULT NULL, 
			                	        	`courseCost`					INT(11) DEFAULT NULL, 
			                	        	`tax`							INT(11) DEFAULT 0, 
			                	        	`payMode`						VARCHAR(255) DEFAULT NULL, 
			                	        	`payId`							VARCHAR(255) DEFAULT NULL, 
			                	        	`payName`						VARCHAR(255) DEFAULT NULL, 
			                	        	`payToken`						VARCHAR(255) DEFAULT NULL, 
			                	        	`currency`						VARCHAR(3) DEFAULT 'usd', 
			                	        	`praivateData`					TEXT DEFAULT NULL, 
			                	        	`iCalUIDforGoogleCalendar`		VARCHAR(60) DEFAULT NULL, 
			                	        	`iCalIDforGoogleCalendar`		VARCHAR(60) DEFAULT NULL, 
			                	        	`resultOfGoogleCalendar`		INT(1) DEFAULT NULL, 
			                	        	`resultModeOfGoogleCalendar`	VARCHAR(60) DEFAULT NULL,
			                   	        	UNIQUE KEY id (`key`)
		                		        	) $charset_collate;";
			
			$table_name = $wpdb->prefix.'booking_package_webhook';
			$this->db_list[$table_name] = "CREATE TABLE ".$table_name." (
			                	        	`key`						INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT, 
			                	        	`target`					VARCHAR(20) DEFAULT NULL,
			                	        	`server`					TEXT DEFAULT NULL, 
			                	        	`post`						TEXT DEFAULT NULL, 
			                	        	`json`						TEXT DEFAULT NULL, 
			                	        	`date`				INT(11) NOT NULL
											) $charset_collate;";
			
            
        }
        
        public function create(){
            
			foreach($this->db_list as $key => $sql){
			    
			    dbDelta($sql);
			    
			}
			
			add_option($this->prefix."db_version", $this->db_version);
			
        }
        
        
        
    }
    
?>