<?php
    
    if(!defined('ABSPATH')){
    	exit;
	}
    
    class Schedule {
        
        public $prefix = null;
        
        public $pluginName = null;
        
        public $automaticApprove = false;
        
        public function __construct($prefix, $pluginName){
            
            $this->prefix = $prefix;
            $this->pluginName = $pluginName;
            
            global $wpdb;
            $table_name = $wpdb->prefix."booking_package_userPraivateData";
            #$wpdb->query("DROP TABLE IF EXISTS ".$table_name.";");
            
        }
        
        public function createFirstCalendar(){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	$sql = "SELECT COUNT(`key`) FROM `".$table_name."`;";
			
			$sql = $wpdb->prepare("SELECT COUNT(`key`) FROM `".$table_name."`;", array());
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				if(intval($row['COUNT(`key`)']) == 0){
					
					#var_dump($row['COUNT(`key`)']);
    				$date = date('U');
    				$wpdb->insert(
    					$table_name, 
    					array(
    						'key' => 1, 
    						'name' => sanitize_text_field('First Calendar'), 
    						'type' => sanitize_text_field('day'), 
    						'status' => sanitize_text_field('open'), 
    						'created' => sanitize_text_field($date), 
    						'uploadDate' => sanitize_text_field($date)
    					), 
    					array('%d', '%s', '%s', '%s', '%s', '%s')
    				);
					
				}
				
				break;
				
			}
        	
        }
        
        public function getCalendarAccountListData(){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."`;", array());
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				
				
			}
			
			return $rows;
        	
        }
        
        public function getCalendarAccount($accountKey = 1){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array($accountKey));
			$row = $wpdb->get_row($sql, ARRAY_A);
			
			return $row;
        	
        }
        
        public function addCalendarAccount(){
        	
        	$date = date('U');
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	
        	$wpdb->insert(
    			$table_name, 
    			array(
    				'name' => sanitize_text_field($_POST['name']), 
    				'type' => sanitize_text_field($_POST['type']), 
    				'status' => sanitize_text_field($_POST['status']), 
    				'courseTitle' => sanitize_text_field($_POST['courseTitle']), 
    				'courseBool' => intval($_POST['courseBool']),
    				'created' => sanitize_text_field($date), 
    				'uploadDate' => sanitize_text_field($date)
    			), 
    			array('%s', '%s', '%s', '%s', '%d', '%s', '%s')
    		);
    		
    		return $this->getCalendarAccountListData();
        	
        }
        
        public function updateCalendarAccount(){
        	
        	$date = date('U');
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	
        	$bool = $wpdb->update( 
        		$table_name,
				array(
					'name' => sanitize_text_field($_POST['name']), 
					'type' => sanitize_text_field($_POST['type']), 
					'status' => sanitize_text_field($_POST['status']), 
					'courseTitle' => sanitize_text_field($_POST['courseTitle']),
					'courseBool' => intval($_POST['courseBool']),
					'googleCalendarID' => sanitize_text_field($_POST['googleCalendarID']),
					'uploadDate' => date('U')
				),
				array('key' => intval($_POST['accountKey'])),
				array('%s', '%s', '%s', '%s', '%d', '%s', '%d'),
				array('%d')
			);
			
        	if($bool === 1){
        		
        		return $this->getCalendarAccountListData();
        		
        	}else{
        		
        		return array("status" => $bool);
        		
        	}
        	
        	
        }
        
        public function deleteCalendarAccount(){
        	
        	global $wpdb;
        	
        	$table_name = $wpdb->prefix."booking_package_form";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_courseData";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_schedule";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_templateSchedule";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	$wpdb->delete($table_name, array('key' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_emailSetting";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	return $this->getCalendarAccountListData();
        	
        }
        
        public function getAccountScheduleData(){
        	
        	$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
        	
        	$month = intval($_POST['month']);
        	$day = intval($_POST['day']);
        	$year = intval($_POST['year']);
        	
			$last_day = date('t', mktime(0, 0, 0, $month, $day, $year));
			$week_start_num = date('w', mktime(0, 0, 0, $month, $day, $year));
			$week_last_num = date('w', mktime(0, 0, 0, $month, $last_day, $year));
			
			$scheduleData = array();
			$jsonAraay = array('completeFlag' => 'accountScheduleData', 'startDay' => '1', 'lastDay' => $last_day, 'startWeek' => $week_start_num, 'lastWeek' => $week_last_num);
			$scheduleData['date'] = $jsonAraay;
			
        	$list = array();
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_schedule";
			$sql = "SELECT year,month,day,accountKey,COUNT(*) FROM `".$table_name."` GROUP BY `year`,`month`,`day`,`accountKey` HAVING `accountKey` = %d AND `year` = %d AND `month` = %d;";
			$valueArray = array(intval($accountKey), intval($year), intval($month));
			
			$sql = $wpdb->prepare($sql, $valueArray);
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				$jsonAraay = array('year' => $row['year'], 'month' => $row['month'], 'day' => $row['day'], 'count' => $row['COUNT(day)'], 'accountKey' => $row['accountKey']);
				$list[$row['day']] = $jsonAraay;
				
			}
			
			$scheduleData['calendar'] = $list;
        	
        	return $scheduleData;
        	
        }
        
        public function getPublicSchedule(){
        	
        	$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
            
        	global $wpdb;
            $table_name = $wpdb->prefix."booking_package_schedule";
			$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d ORDER BY weekKey, hour, min ASC;", array(intval($accountKey), intval($_POST['year']), intval($_POST['month']), intval($_POST['day'])));
            $rows = $wpdb->get_results($sql, ARRAY_A);
            
            return $rows;
        	
        }
        
        public function getTemplateSchedule($weekKey){
        	
        	$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
            
            global $wpdb;
            $table_name = $wpdb->prefix."booking_package_templateSchedule";
			$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `weekKey` = %d ORDER BY weekKey, hour, min ASC;", array(intval($accountKey), intval($weekKey)));
            $rows = $wpdb->get_results($sql, ARRAY_A);
            
            return $rows;
            
        }
        
        public function updateAccountTemplateSchedule(){
        	
        	$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
            
            global $wpdb;
            $array = array('completeFlag' => 'updateAccountTemplateSchedule');
	        $sqlList = array();
	        $valueList = array();
	        $updateTime = date('U');
	        
	        $scheduleRead = array();
		    $i = 0;
		    #$sql = "SELECT * FROM `booking_package_templateSchedule` WHERE `accountKey` = ? AND `weekKey` = ? ORDER BY hour, min ASC;";
		    
		    $table_name = $wpdb->prefix."booking_package_templateSchedule";
		    $valueArray = array(intval($accountKey), intval($_POST['weekKey']));
			$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `weekKey` = %d ORDER BY hour, min ASC;", array($valueArray));
            $rows = $wpdb->get_results($sql, ARRAY_A);
            if(is_null($rows) !== false){
                
                foreach($rows as $row){
                    
                    #var_dump($row);
                    $jsonArray = array(	'key' => $row['key'], 'weekKey' => $row['weekKey'], 'hour' => $row['hour'], 'min' => $row['min'], 
								'title' => $row['title'], 'cost' => $row['cost'], 'holiday' => $row['holiday']);
					$scheduleRead[$i] = $jsonArray;
					$i++;
                    
                }
                
            }
            
            for($i = 0; $i < $_POST['timeCount']; $i++){
			
				$unixTime = mktime(intval($_POST['hour'.$i]), intval($_POST['min'.$i]), 0, intval($_POST['month']), intval($_POST['day0']), intval($_POST['year']));
				$valueArray = array($accountKey, intval($_POST['hour'.$i]), intval($_POST['min'.$i]), intval($_POST['weekKey']));
				$table_name = $wpdb->prefix."booking_package_templateSchedule";
				$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `hour` = %d AND `min` = %d AND `weekKey` = %d;", $valueArray);
				$row = $wpdb->get_row($sql, ARRAY_A);
				if(is_array($row)){
					
					#var_dump($row);
					if($_POST['delete'.$i] == 'true'){
						
						array_push($sqlList, "DELETE FROM `".$table_name."` WHERE `key` = %d;");
						array_push($valueList, array(intval($row['key'])));
						
					}else{
						
						$sql = "UPDATE ".$table_name." SET `hour` = %d, `min` = %d, `title` = %s, `cost` = %d, `capacity` = %d, `stop` = %s WHERE `key` = %d;";
						$value = array(	
							intval($_POST['hour'.$i]), 
							intval($_POST['min'.$i]), 
							sanitize_text_field($_POST['title'.$i]), 
							intval($_POST['cost'.$i]), 
							intval($_POST['capacity'.$i]), 
							sanitize_text_field($_POST['stop'.$i]), 
							intval($row['key'])
						);
						array_push($sqlList, $sql);
						array_push($valueList, $value);
						
					}
					
				}else{
					
					$sql = "INSERT INTO ".$table_name." (`accountKey`, `weekKey` ,`hour`, `min`, `title`, `cost`, `capacity`, `stop`, `holiday`, `uploadDate`) VALUES (%d, %d, %d, %d, %s, %d, %d, %s, %s, %d);";
					$value = array(
						intval($accountKey), 
						intval($_POST['weekKey']), 
						intval($_POST['hour'.$i]), 
						intval($_POST['min'.$i]), 
						sanitize_text_field($_POST['title'.$i]), 
						intval($_POST['cost'.$i]), 
						intval($_POST['capacity'.$i]), 
						sanitize_text_field($_POST['stop'.$i]), 
						'false', 
						$updateTime
					);
					array_push($sqlList, $sql);
					array_push($valueList, $value);
					
				}
				
				
				
			}
			
			$array['sql'] = $sqlList;
			$array['value'] = $valueList;
			
			for($i = 0; $i < count($sqlList); $i++){
				
				$sql = $wpdb->prepare($sqlList[$i], $valueList[$i]);
				$wpdb->query($sql);
				
			}
			
			$year = date('Y');
			$month = date('m');
			$day = date('d');
			$this->insertAccountSchedule($month, $day, $year);
            
        }
        
        public function insertAccountSchedule($month, $day, $year){
    		
    		global $wpdb;
    		$uploadDate = date('U');
    		$const_unixTime = date('U', mktime(0, 0, 0, $month, $day, $year));
    		$maxAccountScheduleDay = intval(get_option($this->prefix.'maxAccountScheduleDay', 7));
    		#var_dump($maxAccountScheduleDay);
    		
    		$table_name = $wpdb->prefix."booking_package_calendarAccount";
			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `status` = %s;", array("open"));
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				$accountKey = $row['key'];
				$unixTime = $const_unixTime;
				for($i = 0; $i < $maxAccountScheduleDay; $i++){
    				
    				$year = date('Y', $unixTime);
					$month = date('m', $unixTime);
					$day = date('d', $unixTime);
					$week = date('w', $unixTime);
					#print $year."_".$month."_".$day."<br>\n";
					$unixTime += 1440 * 60;
					
					$table_name = $wpdb->prefix."booking_package_schedule";
					$sql = "SELECT `key` FROM `".$table_name."` WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d LIMIT 0, 1;";
    				$valueArray = array(intval($accountKey), intval($year), intval($month), intval($day));
    				$row = $wpdb->get_row($wpdb->prepare($sql, $valueArray));
    				
    				if(is_null($row)){
    					
    					$table_name = $wpdb->prefix."booking_package_templateSchedule";
    					$sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `weekKey` = %d ORDER BY `weekKey`, `hour`, `min` ASC;";
    					$template_rows = $wpdb->get_results($wpdb->prepare($sql, array(intval($accountKey), intval($week))), ARRAY_A);
    					foreach($template_rows as $template_row){
    						
    						$time = date('U', mktime($template_row['hour'], $template_row['min'], 0, $month, $day, $year));
    						$table_name = $wpdb->prefix."booking_package_schedule";
    						
    						$wpdb->insert(
    							$table_name, 
    							array(
    								'accountKey' => intval($accountKey), 
    								'unixTime' => intval($time), 
    								'year' => intval($year), 
    								'month' => intval($month), 
    								'day' => intval($day), 
    								'weekKey' => intval($week), 
    								'hour' => intval($template_row['hour']), 
    								'min' => intval($template_row['min']), 
    								'title' => $template_row['title'], 
    								'cost' => intval($template_row['cost']), 
    								'capacity' => intval($template_row['capacity']), 
    								'remainder' => intval($template_row['capacity']), 
    								'stop' => $template_row['stop'], 
    								'holiday' => 'false', 
    								'uploadDate' => $uploadDate
    							), 
    							array('%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%s', '%d', '%d', '%d', '%s', '%s', '%d')
    						);
    						
    					}
    					
    				}
    				
    			}
				
			}
    		
    		/**
    		for($i = 0; $i < $maxAccountScheduleDay; $i++){
    			
    			$year = date('Y', $unixTime);
				$month = date('m', $unixTime);
				$day = date('d', $unixTime);
				$week = date('w', $unixTime);
				#print $year."_".$month."_".$day."<br>\n";
				$unixTime += 1440 * 60;
				
				$table_name = $wpdb->prefix."booking_package_schedule";
				$sql = "SELECT `key` FROM `".$table_name."` WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d LIMIT 0, 1;";
    			$valueArray = array(1, intval($year), intval($month), intval($day));
    			#$sql = $wpdb->prepare($sql, $valueArray);
    			$row = $wpdb->get_row($wpdb->prepare($sql, $valueArray));
    			
    			if(is_null($row)){
    				
    				$table_name = $wpdb->prefix."booking_package_templateSchedule";
    				$sql = "SELECT * FROM `".$table_name."` WHERE `weekKey` = %d ORDER BY `weekKey`, `hour`, `min` ASC;";
    				$rows = $wpdb->get_results($wpdb->prepare($sql, array(intval($week))), ARRAY_A);
    				foreach($rows as $row){
    					
    					$time = date('U', mktime($row['hour'], $row['min'], 0, $month, $day, $year));
    					$table_name = $wpdb->prefix."booking_package_schedule";
    					
    					$wpdb->insert(
    						$table_name, 
    						array(
    							'accountKey' => 1, 
    							'unixTime' => intval($time), 
    							'year' => intval($year), 
    							'month' => intval($month), 
    							'day' => intval($day), 
    							'weekKey' => intval($week), 
    							'hour' => intval($row['hour']), 
    							'min' => intval($row['min']), 
    							'title' => $row['title'], 
    							'cost' => intval($row['cost']), 
    							'capacity' => intval($row['capacity']), 
    							'remainder' => intval($row['capacity']), 
    							'stop' => $row['stop'], 
    							'holiday' => 'false', 
    							'uploadDate' => $uploadDate
    						), 
    						array('%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%s', '%d', '%d', '%d', '%s', '%s', '%d')
    					);
    					
    				}
    				
    				
    			}
    			
    		}
    		**/
    		
    		/**
    		$table_name = $wpdb->prefix."booking_package_schedule";
			$sql = "SELECT year,month,day,accountKey,COUNT(*) FROM `".$table_name."` GROUP BY `year`,`month`,`day`,`accountKey` HAVING `accountKey` = %d AND `year` = %d AND `month` = %d;";
			$valueArray = array(1, intval($_POST['year']), intval($_POST['month']));
			
			$sql = $wpdb->prepare($sql, $valueArray);
			$rows = $wpdb->get_results($sql, ARRAY_A);
    		**/
    		
    	}
    	
    	public function updateAccountSchedule(){
    		
    		$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
    		
    		global $wpdb;
    		$sql = '';
    		$courseTime = 0;
    		$maintenanceTime = 0;
    		
			$array = array();
			$value_array = array();
			$rpeatList = array();
			$prepareForRpeatReservation = array();
			
			$table_name = $wpdb->prefix."booking_package_courseData";
			$sql = "SELECT `key`,max(`time`) FROM `".$table_name."` WHERE `accountKey` = %d;";
    		$row = $wpdb->get_row($wpdb->prepare($sql, array(intval($accountKey))), ARRAY_A);
    		if(is_null($row)){
    			
    			$courseTime = 0;
    			
    		}else{
    			
    			$courseTime = intval($row["max(`time`)"]);
    			
    		}
    		
    		for($i = 0; $i < $_POST['timeCount']; $i++){
    			
    			$updateBool = false;
    			$unixTime = intval(date('U', mktime($_POST['hour'.$i], $_POST['min'.$i], 0, $_POST['month'], $_POST['day'], $_POST['year'])));
    			$weekKey = intval(date('w', mktime($_POST['hour'.$i], $_POST['min'.$i], 0, $_POST['month'], $_POST['day'], $_POST['year'])));
    			
    			if($_POST['key'.$i]){
    				
    				$table_name = $wpdb->prefix."booking_package_schedule";
    				$sql = "SELECT * FROM `".$table_name."` WHERE `key` = %d;";
    				$row = $wpdb->get_row($wpdb->prepare($sql, array(intval($_POST['key'.$i]))), ARRAY_A);
    				if(!is_null($row)){
    					
    					#var_dump($row);
    					$updateBool = true;
    					if($_POST['delete'.$i] == 'true'){
    						
    						$sql = "DELETE FROM `".$table_name."` WHERE `key` = %d;";
    						$updateArray = array(intval($_POST['key'.$i]));
    						
    					}else{
    						
							$capacity = $_POST['capacity'.$i];
							$remainder = $_POST['remainder'.$i];
    						
    						$sql = "UPDATE `".$table_name."` SET `unixTime` = %d, `year` = %d, `month` = %d, `day` = %d, ";
							$sql .= "`hour` = %d, `min` = %d, `title` = %s, `capacity` = %d, `remainder` = %d, `stop` = %s, `cost` = %d ";
							$sql .= "WHERE `key` = %d;";
    						$updateArray = array(
    												$unixTime,
    												intval($_POST['year']),
    												intval($_POST['month']),
    												intval($_POST['day']),
    												intval($_POST['hour'.$i]),
    												intval($_POST['min'.$i]),
    												sanitize_text_field($_POST['title'.$i]),
													intval($capacity),
													intval($remainder),
													sanitize_text_field($_POST['stop'.$i]),
													intval(0),
													intval($_POST['key'.$i])
												);
							
    					}
    					
    				}
    				
    			}else{
    				
    				$remainder = $_POST['capacity'.$i];
    				$remainder = $_POST['remainder'.$i];
    				$reserveRemainder = 0;
    				
    				$table_name = $wpdb->prefix."booking_package_userPraivateData";
    				$serch_sql = "SELECT * FROM `".$table_name."` WHERE `scheduleUnixTime` > %d AND `scheduleUnixTime` < %d AND `accountKey` = %d;";
					$valueArray = array(($unixTime - ($courseTime * 60) - ($maintenanceTime * 60)), $unixTime, array(intval($accountKey)));
    				#var_dump($valueArray);
    				$sql = $wpdb->prepare($serch_sql, $valueArray);
					$rows = $wpdb->get_results($sql, ARRAY_A);
					foreach($rows as $row){
						
						$reserveUnixTime = $row['scheduleUnixTime'] + ($row['courseTime'] * 60);
						if($unixTime < $reserveUnixTime){
							$remainder--;
							$reserveRemainder++;
						}
						
					}
					
					if($remainder < 0){
						
						$updateBool = false;
						
					}else{
						
						$updateBool = true;
						
					}
					
					if($updateBool == true){
						
						$table_name = $wpdb->prefix."booking_package_schedule";
						$sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `unixTime` = %d;";
						$row = $wpdb->get_row($wpdb->prepare($sql, array(intval($accountKey), $unixTime)), ARRAY_A);
						if(is_null($row)){
							
							$sql = "INSERT INTO `".$table_name."` (`accountKey`,`unixTime`,`year`,`month`,`day`, `weekKey`, `hour`,`min`,`title`,`capacity`,`remainder`,`stop`,`holiday`,`cost`) ";
							$sql .= "VALUES (%d, %d, %d, %d, %d, %d, %d, %d, %s, %d, %d, %s, %s, %d);";
							$updateArray = array(
								intval($accountKey),
								$unixTime,
								intval($_POST['year']),
								intval($_POST['month']),
								intval($_POST['day']),
								intval($weekKey),
								intval($_POST['hour'.$i]),
								intval($_POST['min'.$i]),
								sanitize_text_field($_POST['title'.$i]),
								intval($_POST['capacity'.$i]),
								intval($remainder),
								sanitize_text_field($_POST['stop'.$i]),
								"false",
								intval(0)
							);
							
						}
						
					}
    				
    				
    			}
    			
    			if($updateBool == true){
					#var_dump($sql);
					array_push($array, $sql);
					array_push($value_array, $updateArray);
				}
				
				
    			
    		}
    		
    		for($i = 0; $i < count($array); $i++){
					
				$sql = $wpdb->prepare($array[$i], $value_array[$i]);
				#var_dump($sql);
				$wpdb->query($sql);
				
			}
    		
    	}
    	
    	public function deleteOldDaysInSchedules(){
    		
    		global $wpdb;
    		$timezone = get_option('timezone_string');
            date_default_timezone_set($timezone);
            $unixTime = date('U') - (14 * 24 * 3600);
            $unixTime = date('U', mktime(0, 0, 0, date('m', $unixTime), date('d', $unixTime), date('Y', $unixTime)));
            
            $table_name = $wpdb->prefix."booking_package_schedule";
            $sql = $wpdb->prepare("DELETE FROM `".$table_name."` WHERE `unixTime` < %d;", array($unixTime));
            $wpdb->query($sql);
            return $sql;
    		
    	}
    	
    	public function getReservationData($month, $day, $year, $ical = false, $public = false){
    		
    		$accountKey = 1;
    		if(isset($_POST['accountKey'])){
    			
    			$accountKey = $_POST['accountKey'];
    			
    		}
    		
    		global $wpdb;
    		$reserveData = array();
    		
    		if($ical === false){
    			
    			if(is_null($month) && is_null($day) !== true && is_null($year)){
    				
    				$month = date('m');
    				$day = date('d');
    				$year = date('Y');
    				
    			}
    			
    			if($month != date('m') || $year != date('Y')){
    				
    				$day = 1;
    				
    			}else{
    				
    				$day = date('d');
    				
    			}
    			
    			if($public !== false){
    				
    				$unavailableDaysFromToday = get_option($this->prefix."unavailableDaysFromToday", 0) * (1440 * 60);
    				$unixTime = date('U') + $unavailableDaysFromToday;
    				
    				if(date('U', mktime(0, 0, 0, $month, 1, $year)) < $unixTime){
    					
    					$month = date('m', $unixTime);
    					$day = date('d', $unixTime);
    					$year = date('Y', $unixTime);
    					
    				}
    				
    				$reserveData['test'] = array('month' => $month, 'day' => $day, 'year' => $year, 'unixTime' => $unixTime);
    				
    			}
    			
    		}else{
    			
    			
    			
    		}
    		
    		
    		#print "$month / $day / $year";
    		$last_day = date('t', mktime(0, 0, 0, $month, $day, $year));
			$week_start_num = date('w', mktime(0, 0, 0, $month, 1, $year));
			$week_last_num = date('w', mktime(0, 0, 0, $month, $last_day, $year));
			
			
			
			if($ical === false){
				
				$arrayValue = array('startDay' => '1', 'lastDay' => $last_day, 'startWeek' => $week_start_num, 'lastWeek' => $week_last_num, 'year' => $year, 'month' => $month, 'day' => 1);
				$reserveData['date'] = $arrayValue;
				
    			$schedule = array();
    			for($i = 1; $i <= $last_day; $i++){
    				
    				$week = date('w', mktime(0, 0, 0, $month, $i, $year));
    				$arrayValue = array('year' => $year, 'month' => $month, 'day' => $i, 'week' => $week, 'select' => 'false');
    				$schedule[$i] = $arrayValue;
    				
    			}
    			
    			
            	$table_name = $wpdb->prefix."booking_package_schedule";
				$sql = $wpdb->prepare("SELECT year,month,day,accountKey,SUM(capacity),SUM(remainder),COUNT(day) FROM `".$table_name."` GROUP BY `year`,`month`,`day`,`holiday`,`accountKey` HAVING `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` >= %d AND `holiday` = 'false';", array(intval($accountKey), intval($year), intval($month), intval($day)));
				
				$rows = $wpdb->get_results($sql, ARRAY_A);
				foreach($rows as $row){
					
					$week = date('w', mktime(0, 0, 0, $row['month'], $row['day'], $row['year']));
					$p = floor(($row['SUM(remainder)'] / $row['SUM(capacity)']) * 100);
					$arrayValue = array('year' => $row['year'], 'month' => $row['month'], 'day' => $row['day'], 'week' => $week, 'select' => 'true', 'count' => $row['COUNT(day)'], 'capacity' => $row['SUM(capacity)'], 'remainder' => $row['SUM(remainder)'], 'p' => $p);
					$schedule[$row['day']] = $arrayValue;
					
				}
				
				$reserveData['calendar'] = $schedule;
				
				$reservation = array();
				$schedule = array();
				$schedule_start_day = null;
				if($public !== false){
					
					$schedule_start_day = $day;
					
				}
				for($i = 1; $i <= $last_day; $i++){
					
					$table_name = $wpdb->prefix."booking_package_schedule";
					$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d AND `holiday` = 'false';", array(intval($accountKey), intval($year), intval($month), intval($i)));
					$rows = $wpdb->get_results($sql, ARRAY_A);
					$schedule[$i] = $rows;
					if(!is_null($schedule_start_day) && $i < $schedule_start_day){
						
						$schedule[$i] = array();
						
					}
					
					if($public == false){
						
						$startUnixTime = date('U', mktime(0, 0, 0, $month, $i, $year));
						$stopUnixTime = $startUnixTime + (1440 * 60);
						$table_name = $wpdb->prefix."booking_package_userPraivateData";
						$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `scheduleUnixTime` >= %d AND `scheduleUnixTime` < %d ORDER BY `scheduleUnixTime` ASC;", array(intval($accountKey), $startUnixTime, $stopUnixTime));
						$rows = $wpdb->get_results($sql, ARRAY_A);
						if(is_null($rows) === false && count($rows) != 0){
							
							for($row = 0; $row < count($rows); $row++){
								
								$json = json_decode($rows[$row]['praivateData']);
								$rows[$row]['praivateData'] = $json;
								$unixTime = $rows[$row]['scheduleUnixTime'];
								#$rows[$row]['date'] = array('month' => (date('n', $unixTime) - 1), 'day' => date('d', $unixTime), 'year' => date('Y', $unixTime), 'week' => date('w', $unixTime), 'hour' => date('H', $unixTime), 'min' => date('i', $unixTime), 'timeZone' => date('e', $unixTime));
								$rows[$row]['date'] = array('month' => date('n', $unixTime), 'day' => date('d', $unixTime), 'year' => date('Y', $unixTime), 'week' => date('w', $unixTime), 'hour' => date('H', $unixTime), 'min' => date('i', $unixTime), 'timeZone' => date('e', $unixTime));
								
							}
							
							$reservation[$i] = $rows;
							
						}
						
					}
					
					
				}
				$reserveData['schedule'] = $schedule;
				$reserveData['reservation'] = $reservation;
				
			}else{
				
				$table_name = $wpdb->prefix."booking_package_userPraivateData";
				$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `scheduleUnixTime` >= %d ORDER BY `scheduleUnixTime` ASC;", array(intval($accountKey), $startUnixTime));
				$rows = $wpdb->get_results($sql, ARRAY_A);
				#var_dump($rows);
				if(is_null($rows) === false && count($rows) != 0){
						
					for($row = 0; $row < count($rows); $row++){
						
						$json = json_decode($rows[$row]['praivateData']);
						$rows[$row]['praivateData'] = $json;
						$unixTime = $rows[$row]['scheduleUnixTime'];
						$rows[$row]['date'] = array('unixTime' => $unixTime, 'month' => date('m', $unixTime), 'day' => date('d', $unixTime), 'year' => date('Y', $unixTime), 'week' => date('w', $unixTime), 'hour' => date('H', $unixTime), 'min' => date('i', $unixTime), 'timeZone' => date('e', $unixTime));
						
					}
					
					$reserveData = $rows;
					
				}
				
			}
    		
			return $reserveData;
			
    	}
    	
    	public function serachCourse($accountKey, $key = false, $time = false){
    		
    		global $wpdb;
    		$table_name = $wpdb->prefix."booking_package_courseData";
    		if($key !== false){
    			
    			$sql = $wpdb->prepare("SELECT `key`,`name`,`time`,`cost` FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d LIMIT 0, 1;", array(intval($accountKey), intval($key)));
    			
    		}
    		
    		if($time != false){
    			
    			$sql = $wpdb->prepare("SELECT `key`,`name`,`time`,`cost` FROM `".$table_name."` WHERE `accountKey` = %d AND `time` = %d LIMIT 0, 1;", array(intval($accountKey), intval($time)));
    			
    		}
    		$row = $wpdb->get_row($sql, ARRAY_A);
    		if(is_null($row)){
    			
    			return array('status' => 'error');
    			
    		}else{
    			
    			return $row;
    			
    		}
    		
    	}
    	
    	public function getStatus($userDetail = false){
    		
    		#$this->automaticApprove = boolval(intval(get_option($this->prefix."automaticApprove", 0)));
    		$this->automaticApprove = intval(get_option($this->prefix."automaticApprove", 0));
    		if($this->automaticApprove == 0){
	    		
	    		$this->automaticApprove = false;
	    		
    		}else {
	    		
	    		$this->automaticApprove = true;
	    		
    		}
    		$status = "pending";
    		if($userDetail !== false){
    			
    			if(isset($userDetail['status'])){
    				
    				return $userDetail['status'];
    				
    			}else{
    				
    				if($this->automaticApprove === true){
    					
    					$status = "approved";
    					
    				}
    				
    			}
    			
    		}else{
    			
    			if($this->automaticApprove === true){
    				
    				$status = "approved";
    				
    			}
    			
    		}
    		
    		return $status;
    		
    	}
    	
    	public function serachSchedule($unixTime, $accountKey = 1){
    		
    		global $wpdb;
    		$table_name = $wpdb->prefix."booking_package_schedule";
    		$sql = $wpdb->prepare("SELECT `key`,`unixTime`,`title`,`capacity`,`remainder`,`stop` FROM `".$table_name."` WHERE `accountKey` = %d AND `unixTime` = %d LIMIT 0, 1;", array(intval($accountKey), intval($unixTime)));
    		$row = $wpdb->get_row($sql, ARRAY_A);
    		if(is_null($row)){
    			
    			return array('status' => 'error');
    			
    		}else{
    			
    			return $row;
    			
    		}
    		
    	}
    	
    	public function sendBooking(){
    		
    		$accountKey = 1;
    		if(isset($_POST['accountKey'])){
    			
    			$accountKey = $_POST['accountKey'];
    			
    		}
    		
    		$maintenanceTime = 0;
    		$remainderTime = 0;
    		$sendDate = date('U');
    		$totalCost = 0;
    		$courseKey = null;
    		$ressponse = array();
    		$sql_start_unixTime = null;
    		$sql_max_unixTime = null;
    		
    		global $wpdb;
    		
    		$calendarAccount = $this->getCalendarAccount($accountKey);
    		
    		$form = $this->getUserValues($accountKey);
    		if(isset($form['status']) && $form['status'] == 'error'){
    			
    			return $form;
    			
    		}
    		
    		
    		#return array("status" => "error", "message" => "Test", "form" => $form, "email" => $email);
    		
    		$currency = get_option($this->prefix."currency", 'usd');
    		
    		$table_name = $wpdb->prefix."booking_package_schedule";
    		$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['timeKey'])));
    		$row = $wpdb->get_row($sql, ARRAY_A);
    		if(is_null($row)){
    			
    			return array('status' => 'error', 'error' => '9016');
    			
    		}else{
    			
    			$scheduleUnixTime = intval($_POST['unixTime']);
    			$applicantCount = intval($_POST['applicantCount']);
    			$startTime = $row['unixTime'];
    			$sql_start_unixTime = $row['unixTime'];
    			
    			$scheduleTitle = $row['title'];
				$scheduleCost = intval($row['cost']);
				$totalCost += intval($row['cost']) * $applicantCount;
				
				if($row['unixTime'] == $scheduleUnixTime){
					
					$table_name = $wpdb->prefix."booking_package_schedule";
					$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
					$valueArray = array(intval($accountKey), intval($_POST['timeKey']));
					if(isset($_POST['courseKey'])){
						
						$row = $this->serachCourse($accountKey ,$_POST['courseKey']);
						#$table_name = $wpdb->prefix."booking_package_courseData";
            			#$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `key` = %d;", array(intval($_POST['courseKey'])));
            			#$row = $wpdb->get_row($sql, ARRAY_A);
            			#if(is_null($row)){
            			if($row['status'] == 'error'){
            				
            				return array('status' => 'error', 'error' => '9020');
            				
            			}else{
            				
            				$courseKey = $_POST['courseKey'];
            				$courseName .= $row['name']."\n";
							$courseCost += intval($row['cost']);
							$courseTime += $row['time'];
							$totalCost += intval($row['cost']) * $applicantCount;
							
							$sql_max_unixTime = $sql_start_unixTime + ($courseTime * 60) + ($maintenanceTime * 60);
							$table_name = $wpdb->prefix."booking_package_schedule";
							$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC ;";
							$valueArray = array(intval($accountKey), intval($sql_start_unixTime), intval($sql_max_unixTime));
            				
            			}
						
					}
					
					/** Stripe **/
					$cardToken = null;
					if(isset($_POST['payToken'])){
						
						$stripe_active = get_option($this->prefix."stripe_active", "0");
						$stripe_secret_key = get_option($this->prefix."stripe_secret_key", null);
						$currency = get_option($this->prefix."currency", "usd");
						if($stripe_active == 1 && !is_null($stripe_secret_key)){
							
							$creditCard = new creditCard($this->pluginName);
							$payResponse = $creditCard->pay("stripe", $stripe_secret_key, $_POST['payToken'], $totalCost, $currency, $key, $name);
							if(isset($payResponse['error'])){
								
								return array('status' => 'error', 'error' => $payResponse['error']);
								
							}else{
								
								$cardToken = $payResponse['cardToken'];
								
							}
							
						}
						
					}
					/** Stripe **/
					
					#$automaticApprove = boolval(intval(get_option($this->prefix."automaticApprove", 0)));
					$status = $this->getStatus();
					/**
					#$status = "pending";
					if($this->automaticApprove === true){
						
						#$status = "approved";
						$updateSchedule = $this->updateRemainderSeart("increase", $account_sql, $valueArray, $applicantCount);
						
					}
					**/
					
					$updateSchedule = $this->updateRemainderSeart("increase", $account_sql, $valueArray, $applicantCount);
					$lastID = $this->insertPrivateData($sendDate, $_POST['permission'], $status, $_POST['timeKey'], $scheduleUnixTime, $scheduleTitle, $scheduleCost, $courseKey, $courseName, $courseTime, $courseCost, $form, $currency, $cardToken, $accountKey, $applicantCount);
					
				}
    			
    		}
    		
    		$mailBody = null;
    		if(intval($_POST['sendEmail']) == 1){
    			
    			#$to = $this->emailFormat(get_option($this->prefix."email_to", null), get_option($this->prefix."email_title_to", null));
    			#$from = $this->emailFormat(get_option($this->prefix."email_from", null), get_option($this->prefix."email_title_from", null));
    			
    			#$emailFormat = get_option($this->prefix."mail_new_admin_format", null);
    			#$emailSubject = get_option($this->prefix."mail_new_admin_subject", null);
    			#$emailBody = get_option($this->prefix."mail_new_admin_content", null);
    			$email = $this->createEmailMessage($accountKey, array('mail_new_admin'), $form, $lastID, $scheduleUnixTime, $emailSubject, $emailBody, $emailFormat, $to, $from, $courseName, $scheduleTitle);
    			
    		}
    		
    		$setting = new setting($this->prefix, $this->pluginName);
    		#$updateChannel = $setting->updateChannelGC();
    		$googleCalendar = $setting->pushGC('insert', $accountKey, $lastID, $calendarAccount['googleCalendarID'], $sql_start_unixTime, $sql_max_unixTime, $form);
    		$this->updateQueueForGC($lastID, $googleCalendar);
    		
    		$iCal = false;
    		$public = false;
    		if(intval($_POST['public']) == 1){
    			
    			$public = true;
    			
    		}
    		
    		$ressponse = $this->getReservationData(intval($_POST['month']), intval($_POST['day']), intval($_POST['year']), $iCal, $public);
    		$ressponse['automaticApprove'] = $this->automaticApprove;
    		#$ressponse['payResponse'] = $payResponse;
    		#$ressponse['Google_Calendar'] = $googleCalendar;
    		$ressponse['updateChannel'] = $updateChannel;
    		$ressponse['lastID'] = $lastID;
    		$ressponse['params'] = $params;
    		
    		$ressponse['status'] = "success";
    		return $ressponse;
    		
    		
    	}
    	
    	public function insertPrivateData($sendDate, $permission, $status, $timeKey, $scheduleUnixTime, $scheduleTitle, $scheduleCost, $courseKey, $courseName, $courseTime, $courseCost, $form, $currency, $cardToken, $accountKey, $applicantCount = 1){
    		
    		global $wpdb;
    		
    		$maintenanceTime = 0;
    		$remainderBool = 'false';
			if(($sendDate + ($remainderTime * 60)) > $scheduleUnixTime){
				
				$remainderBool = 'true';
				
			}
			
			$courseTitle = get_option($this->prefix."courseName", "Course");
			$numberOfWeek = ceil(date('d', $scheduleUnixTime) / 7);
			
			#$courseKey = intval($_POST['courseKey']);
			if(is_null($courseKey)){
				
				$courseKey = null;
				
			}
			
			$payMode = "";
			$payId = "";
			$payName = "";
			if($cardToken != null){
				
				$payMode = "CreditCard";
				$payId = "stripe";
				$payName = "Stripe";
				
			}
			
			$table_name = $wpdb->prefix."booking_package_userPraivateData";
			$valueArray = array(
    		 					'reserveTime' => intval($sendDate), 
    		 					'remainderTime' => 0,
    							'remainderBool' => $remainderBool, 
    							'maintenanceTime' => intval($maintenanceTime),
    							'permission' => sanitize_text_field($permission),
    							'status' => sanitize_text_field($status),
    							'accountKey' => intval($accountKey),
    							'accountName' => '',
    							'scheduleUnixTime' => intval($scheduleUnixTime),
    							'scheduleWeek' => intval($numberOfWeek),
    							'scheduleTitle' => sanitize_text_field($scheduleTitle),
    							'scheduleKey' => intval($timeKey),
    							'scheduleCost' => intval($scheduleCost),
    							'applicantCount' => intval($applicantCount),
    							'courseKey' => sanitize_text_field($courseKey),
    							'courseTitle' => sanitize_text_field($courseTitle),
    							'courseName' => sanitize_text_field($courseName),
    							'courseTime' => intval($courseTime),
    							'courseCost' => intval($courseCost),
    							'currency' => sanitize_text_field($currency),
    							'payMode' => $payMode,
    							'payId' => $payId,
    							'payName' => $payName,
    							'payToken' => sanitize_text_field($cardToken),
    							'praivateData' => json_encode($form)
    						);
    		
			$bool = $wpdb->insert(	$table_name, 
    								$valueArray, 
    								array(	'%d', '%d', '%s', '%d', '%s', '%s', '%d', '%s', '%d', '%d', 
    										'%s', '%d', '%d', '%d', '%s', '%s', '%s', '%d', '%d', '%s',
    										'%s', '%s', '%s', '%s', '%s'
    								)
    							);
			#$ressponse['insert'] = $bool;
			$lastID = $wpdb->insert_id;
			
			return $lastID;
    		
    	}
    	
    	public function deleteBookingData($deleteKey = false, $sendGC = true){
    		
    		$accountKey = 1;
    		if(isset($_POST['accountKey'])){
    			
    			$accountKey = $_POST['accountKey'];
    			
    		}
    		
    		global $wpdb;
    		$calendarAccount = $this->getCalendarAccount($accountKey);
    		if($deleteKey !== false){
    			
    			$unixTimeStart = 0;
    			$form = null;
    			$table_name = $wpdb->prefix."booking_package_userPraivateData";
    			$sql = "SELECT * FROM `".$table_name."` WHERE `key` = %d;";
    			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($deleteKey)));
    			$row = $wpdb->get_row($sql, ARRAY_A);
            	if(is_null($row) === false){
            		
            		$accountKey = $row['accountKey'];
            		$iCalIDforGoogleCalendar = $row['iCalIDforGoogleCalendar'];
            		$form = json_decode($row['praivateData']);
            		$table_name = $wpdb->prefix."booking_package_schedule";
            		$sql = null;
            		$month = date('m', $row['scheduleUnixTime']);
            		$year = date('Y', $row['scheduleUnixTime']);
            		$applicantCount = $row['applicantCount'];
            		$payToken = $row['payToken'];
            		$scheduleTitle = $row['scheduleTitle'];
            		$courseName = $row['courseName'];
            		$unixTimeStart = $row['scheduleUnixTime'];
					$unixTimeEnd = $row['scheduleUnixTime'] + ($row['courseTime'] * 60) + ($row['maintenanceTime'] * 60);
					$valueArray = array();
            		if(strlen($row['courseKey']) != 0){
            			
            			$sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            			$valueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
            			
            		}else{
            			
            			$sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            			$valueArray = array(intval($accountKey), intval($row['scheduleKey']));
            			
            		}
            		
            		/**
            		if($row['status'] == 'approved'){
            			
            			$updateSchedule = $this->updateRemainderSeart("reduce", $sql, $valueArray, $applicantCount);
            			
            		}
            		**/
            		
            		$updateSchedule = $this->updateRemainderSeart("reduce", $sql, $valueArray, $applicantCount);
            		
            		if(isset($_POST['refound']) && intval($_POST['refound']) == 1){
            			
            			$stripe_active = get_option($this->prefix."stripe_active", "0");
						$stripe_secret_key = get_option($this->prefix."stripe_secret_key", null);
						$currency = get_option($this->prefix."currency", "usd");
						if($stripe_active == 1 && !is_null($stripe_secret_key)){
							
							#$payToken
            				$creditCard = new creditCard();
            				$refound = $creditCard->cancel("stripe", $stripe_secret_key, $payToken);
							
						}
            			
            		}
            		
            		$table_name = $wpdb->prefix."booking_package_userPraivateData";
            		$wpdb->delete($table_name, array('key' => intval($deleteKey)), array('%d'));
            		
            		$ressponse = $this->getReservationData($month, 1, $year);
    				$ressponse['status'] = "success";
    				$ressponse['refound'] = $refound;
    				
    				$mailBody = null;
    				#if(intval(get_option($this->prefix."mail_deleted_enable", null)) == 1 && intval($_POST['sendEmail']) == 1){
    				if(intval($_POST['sendEmail']) == 1){
    					
    					#$to = $this->emailFormat(get_option($this->prefix."email_to", null), get_option($this->prefix."email_title_to", null));
    					#$from = $this->emailFormat(get_option($this->prefix."email_from", null), get_option($this->prefix."email_title_from", null));
    					
    					#$emailFormat = get_option($this->prefix."mail_deleted_format", null);
    					#$emailSubject = get_option($this->prefix."mail_deleted_subject", null);
    					#$emailBody = get_option($this->prefix."mail_deleted_content", null);
    					$email = $this->createEmailMessage($accountKey, array('mail_deleted'), $form, $deleteKey, intval($unixTimeStart), $emailSubject, $emailBody, $emailFormat, $to, $from, $courseName, $scheduleTitle);
    					$ressponse['email'] = $email;
    					
    				}
    				
    				if($sendGC === true){
    					
    					$setting = new setting($this->prefix, $this->pluginName);
    					$ressponse['delete'] = $setting->deleteGC($accountKey, $iCalIDforGoogleCalendar, $calendarAccount['googleCalendarID']);
    					
    				}
    				
            		
            		return $ressponse;
            		
            	}else{
            		
            		return array('error' => 'ERROR3', 'status' => 'error');
            		
            	}
    			
    		}
    		
    	}
    	
    	public function retryToSendToServer(){
    		
    		global $wpdb;
    		$setting = new setting($this->prefix, $this->pluginName);
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `resultOfGoogleCalendar` = %d;", array(0));
			$rows = $wpdb->get_results($sql, ARRAY_A);
			if(is_null($rows) === false && count($rows) != 0){
				
				for($row = 0; $row < count($rows); $row++){
					
					
					$form = json_decode($rows[$row]['praivateData']);
					$data = $rows[$row];
					$accountKey = $data['accountKey'];
					$key = $data['key'];
					$sql_start_unixTime = $data['scheduleUnixTime'];
					$sql_max_unixTime = $sql_start_unixTime + ($data['courseTime'] * 60) + ($data['maintenanceTime'] * 60);
					#var_dump($data);
					$iCalID = false;
					if(!is_null($data['iCalIDforGoogleCalendar']) && is_string($data['iCalIDforGoogleCalendar'])){
						
						$iCalID = $data['iCalIDforGoogleCalendar'];
						
					}
					
					$calendarAccount = $this->getCalendarAccount($accountKey);
					
					$googleCalendar = $setting->pushGC(
						$data['resultModeOfGoogleCalendar'], 
						$accountKey, 
						$key, 
						$calendarAccount['googleCalendarID'],
						$sql_start_unixTime, 
						$sql_max_unixTime, 
						$form,
						$iCalID
					);
					
					$this->updateQueueForGC($key, $googleCalendar);
					
				}
				
			}
    		
    	}
    	
    	public function updateQueueForGC($key, $googleCalendar){
    		
    		global $wpdb;
    		if(isset($googleCalendar->responseStatus) && isset($googleCalendar->responseMode)){
    			
    			$valueList = array(
    				'resultOfGoogleCalendar' => intval($googleCalendar->responseStatus), 
    				'resultModeOfGoogleCalendar' => sanitize_text_field($googleCalendar->responseMode)
    			);
    			$formatList = array('%s', '%s');
    			if(isset($googleCalendar->id)){
    				
    				$valueList['iCalIDforGoogleCalendar'] = sanitize_text_field($googleCalendar->id);
    				array_push($formatList, '%s');
    				
    			}
    			
    			$table_name = $wpdb->prefix."booking_package_userPraivateData";
    			$bool = $wpdb->update(  
    				$table_name,
                    /**array('iCalIDforGoogleCalendar' => sanitize_text_field($googleCalendar->id)),**/
					$valueList,
					array('key' => intval($key)),
					$formatList,
					array('%d')
				);
    				
    		}
    		
    	}
    	
    	public function updateBooking(){
    		
    		$accountKey = 1;
    		if(isset($_POST['accountKey'])){
    			
    			$accountKey = $_POST['accountKey'];
    			
    		}
    		
    		global $wpdb;
    		$calendarAccount = $this->getCalendarAccount($accountKey);
    		$form = $this->getUserValues($accountKey);
    		if(isset($form['status']) && $form['status'] == 'error'){
    			
    			return $form;
    			
    		}
    		
    		$unixTimeStart = 0;
    		$unixTimeEnd = 0;
    		$maintenanceTime = 0;
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$sql = "SELECT * FROM `".$table_name."` WHERE `key` = %d;";
    		$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['updateKey'])));
    		$row = $wpdb->get_row($sql, ARRAY_A);
            if(is_null($row) === false){
            	
            	$applicantCount = $row['applicantCount'];
            	$iCalIDforGoogleCalendar = $row['iCalIDforGoogleCalendar'];
				#$form = json_decode($row['praivateData']);
				$unixTimeStart = $row['scheduleUnixTime'];
				$unixTimeEnd = $row['scheduleUnixTime'] + ($row['courseTime'] * 60) + ($row['maintenanceTime'] * 60);
				
            	if(isset($_POST['update_booking_date']) || isset($_POST['update_booking_course'])){
            		
            		define("COURSE_KEY", $row['courseKey']);
    				
    				$table_name = $wpdb->prefix."booking_package_schedule";
    				
    				$scheduleKey = $row['scheduleKey'];
    				$scheduleUnixTime = $row['scheduleUnixTime'];
    				$scheduleTitle = $row['scheduleTitle'];
    				$scheduleCost = $row['scheduleCost'];
    				$scheduleWeek = $row['scheduleWeek'];
    				
    				$courseKey = $row['courseKey'];
    				$courseName = $row['courseName'];
    				$courseTime = $row['courseTime'];
    				$courseCost = $row['courseCost'];
    				
            		$unixTimeStart = $scheduleUnixTime;
					$unixTimeEnd = $scheduleUnixTime + ($courseTime * 60) + ($row['maintenanceTime'] * 60);
					$deleteValueArray = array();
            		if(strlen(COURSE_KEY) != 0){
            			
            			$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            			$deleteValueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
            			$sql = $wpdb->prepare($deleteSql, $deleteValueArray);
            			#var_dump($sql);
            			
            		}else{
            			
            			$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            			$deleteValueArray = array(intval($accountKey), intval($scheduleKey));
            			
            		}
            		
            		if(isset($_POST['update_booking_date'])){
    					
    					$table_name = $wpdb->prefix."booking_package_schedule";
    					$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['update_booking_date'])));
    					$rowSchedule = $wpdb->get_row($sql, ARRAY_A);
    					if(is_null($rowSchedule)){
    						
    						return array('status' => 'error', 'error' => '9016');
    						
    					}else{
    						
    						$scheduleKey = $rowSchedule['key'];
    						$scheduleUnixTime = $rowSchedule['unixTime'];
    						$scheduleTitle = $rowSchedule['title'];
    						$scheduleCost = $rowSchedule['cost'];
    						$scheduleWeek = $rowSchedule['weekKey'];
    						
    					}
    					
    				}
    				
    				if(isset($_POST['update_booking_course'])){
    					
    					$rowCourse = $this->serachCourse($accountKey, $_POST['update_booking_course']);
						if($rowCourse['status'] == 'error'){
            				
            				return array('status' => 'error', 'error' => '9020');
            				
            			}else{
            				
            				$courseKey = $rowCourse['key'];
    						$courseName = $rowCourse['name'];
    						$courseTime = $rowCourse['time'];
    						$courseCost = $rowCourse['cost'];
            				
            			}
    					
    				}
    				
    				$unixTimeStart = $scheduleUnixTime;
					$unixTimeEnd = $scheduleUnixTime + ($courseTime * 60) + ($row['maintenanceTime'] * 60);
					$updateValueArray = array();
    				if(strlen(COURSE_KEY) != 0){
            			
            			$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            			$updateValueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
            			
            		}else{
            			
            			$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            			$updateValueArray = array(intval($accountKey), intval($scheduleKey));
            			
            		}
            		
            		/**
            		if($row['status'] == 'approved'){
            			
            			$updateSchedule = $this->updateRemainderSeart("reduce", $deleteSql, $deleteValueArray, $applicantCount);
            			$updateSchedule = $this->updateRemainderSeart("increase", $updateSql, $updateValueArray, $applicantCount);
            			
            		}
            		**/
            		
            		$updateSchedule = $this->updateRemainderSeart("reduce", $deleteSql, $deleteValueArray, $applicantCount);
            		$updateSchedule = $this->updateRemainderSeart("increase", $updateSql, $updateValueArray, $applicantCount);
            		
            		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    				$bool = $wpdb->update(
    					$table_name,
                    	array(
                    		'scheduleKey' => intval($scheduleKey), 
                    		'scheduleUnixTime' => intval($scheduleUnixTime),
                    		'scheduleTitle' => sanitize_text_field($scheduleTitle), 
                    		'scheduleCost' => intval($scheduleCost), 
                    		'scheduleWeek' => intval($scheduleWeek),
                    		'courseKey' => sanitize_text_field($courseKey), 
                    		'courseName' => sanitize_text_field($courseName),
                    		'courseTime' => intval($courseTime),
                    		'courseCost' => intval($courseCost)
                    	),
                    	array('key' => intval($_POST['updateKey'])),
                    	array('%d', '%d', '%s', '%d', '%d', '%s', '%s', '%d', '%d'),
                    	array('%d')
					);
    				
    			}
            	
            	
            	
				
				$table_name = $wpdb->prefix."booking_package_userPraivateData";
    			$bool = $wpdb->update(
    				$table_name,
    				array('praivateData' => json_encode($form)),
    				array('key' => intval($_POST['updateKey'])),
    				array('%s'),
    				array('%d')
				);
				
            }
    		
    		
					
			$googleCalendar = array();
    		if(strlen($iCalIDforGoogleCalendar) != 0){
    			
    			$setting = new setting($this->prefix, $this->pluginName);
    			$googleCalendar = $setting->pushGC('update', $accountKey, intval($_POST['updateKey']), $calendarAccount['googleCalendarID'], $unixTimeStart, $unixTimeEnd, $form, $iCalIDforGoogleCalendar);
    			$this->updateQueueForGC(intval($_POST['updateKey']), $googleCalendar);
    			
    		}else{
    			
    			$googleCalendar['error'] = "No ID";
    			
    		}
    		
    		$ressponse = $this->getReservationData(intval($_POST['month']), 1, intval($_POST['year']));
    		$ressponse['googleCalendar'] = $googleCalendar;
    		$ressponse['status'] = "success";
            
            return $ressponse;
    		
    	}
    	
    	public function updateICalIDforGoogleCalendar($id, $iCalIDforGoogleCalendar){
    		
    		global $wpdb;
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$bool = $wpdb->update(  
    								$table_name,
    								array('iCalIDforGoogleCalendar' => sanitize_text_field($iCalIDforGoogleCalendar)),
									array('key' => intval($id)),
									array('%s'),
									array('%d')
								);
    		
    	}
    	
    	public function updateStatus(){
    		
    		global $wpdb;
    		
    		$iCalIDforGoogleCalendar = null;
    		$unixTimeStart = 0;
    		$unixTimeEnd = 0;
    		$maintenanceTime = 0;
    		$form = null;
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$sql = "SELECT * FROM `".$table_name."` WHERE `key` = %d;";
    		$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['key'])));
    		$row = $wpdb->get_row($sql, ARRAY_A);
            if(is_null($row) === false){
            	
            	$accountKey = $row['accountKey'];
            	$iCalIDforGoogleCalendar = $row['iCalIDforGoogleCalendar'];
				$form = json_decode($row['praivateData']);
				$applicantCount = $row['applicantCount'];
				$scheduleTitle = $row['scheduleTitle'];
				$unixTimeStart = $row['scheduleUnixTime'];
				$courseName = $row['courseName'];
				$account_sql = null;
				$valueArray = array();
				$table_name = $wpdb->prefix."booking_package_schedule";
				$unixTimeEnd = $row['scheduleUnixTime'] + ($row['courseTime'] * 60) + ($row['maintenanceTime'] * 60);
				$valueArray = array();
            	if(strlen($row['courseKey']) != 0){
            		
            		$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            		$valueArray = array(1, intval($unixTimeStart), intval($unixTimeEnd));
            		
            	}else{
            		
            		$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            		$valueArray = array(1, intval($row['scheduleKey']));
            		
            	}
            	
            	/**
            	if($_POST['status'] == "approved"){
    				
    				$updateSchedule = $this->updateRemainderSeart("increase", $account_sql, $valueArray, $applicantCount);
    				
    			}else if($_POST['status'] == "pending"){
    				
            		$updateSchedule = $this->updateRemainderSeart("reduce", $account_sql, $valueArray, $applicantCount);
    				
    			}
    			**/
    			
    			$table_name = $wpdb->prefix."booking_package_userPraivateData";
    			$bool = $wpdb->update(  $table_name,
                            		array('status' => sanitize_text_field($_POST['status'])),
                            		array('key' => intval($_POST['key'])),
                            		array('%s'),
                            		array('%d')
								);
            		
            }
            
            $email_id = null;
            $enableEmail = null;
            $emailFormat = null;
            $emailSubject = null;
            $emailBody = null;
            if($_POST['status'] == "pending"){
            	
            	$email_id = 'mail_pending';
            	
            	$enableEmail = intval(get_option($this->prefix."mail_pending_enable", null));
            	$emailFormat = get_option($this->prefix."mail_pending_format", null);
    			$emailSubject = get_option($this->prefix."mail_pending_subject", null);
    			$emailBody = get_option($this->prefix."mail_pending_content", null);
            	
            }else if($_POST['status'] == "approved"){
            	
            	$email_id = 'mail_approved';
            	
            	$enableEmail = intval(get_option($this->prefix."mail_approved_enable", null));
            	$emailFormat = get_option($this->prefix."mail_approved_format", null);
    			$emailSubject = get_option($this->prefix."mail_approved_subject", null);
    			$emailBody = get_option($this->prefix."mail_approved_content", null);
            	
            }
            
            $mailBody = null;
    		#if($enableEmail == 1 && intval($_POST['sendEmail']) == 1){
    		if(intval($_POST['sendEmail']) == 1){
    			
    			#$to = $this->emailFormat(get_option($this->prefix."email_to", null), get_option($this->prefix."email_title_to", null));
    			#$from = $this->emailFormat(get_option($this->prefix."email_from", null), get_option($this->prefix."email_title_from", null));
    			
    			$email = $this->createEmailMessage($accountKey, array($email_id), $form, intval($_POST['key']), intval($unixTimeStart), $emailSubject, $emailBody, $emailFormat, $to, $from, $courseName, $scheduleTitle);
    			#return $email;
    		}
    		
    		
    		
    		$ressponse = $this->getReservationData(intval($_POST['month']), 1, intval($_POST['year']));
    		$ressponse['status'] = "success";
    		$ressponse['googleCalendar'] = $googleCalendar;
    		return $ressponse;
    		
    	}
    	
    	public function changeBookingTime($mode, $updateKey, $updateScheduleKey, $status, $applicantCount, $newTimeStart, $newTimeEnd, $oldTimeStart, $oldTimeEnd, $accountKey = 1){
    		
    		global $wpdb;
    		
    		$changeBool = true;
    		$scheduleDetail = null;
    		$table_name = $wpdb->prefix."booking_package_schedule";
    		$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC ;";
			$updateValue = array(intval($accountKey), intval($newTimeStart), intval($newTimeEnd));
			if($newTimeStart == $newTimeEnd){
				
				$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `unixTime` = %d;";
				$updateValue = array(intval($accountKey), intval($newTimeStart));
				
			}
    		$sql = $wpdb->prepare($updateSql, $updateValue);
    		#var_dump($sql);
			$rows = $wpdb->get_results($sql, ARRAY_A);
			
			if(count($rows) == 0 || $rows[0]['unixTime'] != $newTimeStart){
				
				return array('status' => 'error', 'event' => 'return', 'message' => 'There is no booking schedule.');
				
			}
			
			
			foreach($rows as $row){
				
				if(!is_null($oldTimeStart) && !is_null($oldTimeEnd)){
					
					if($oldTimeStart != $oldTimeEnd){
						
						if($oldTimeStart <= $row['unixTime'] && $oldTimeEnd > $row['unixTime']){
							
							$row['remainder'] += $applicantCount;
							
						}
						
					}else{
						
						if($oldTimeStart == $row['unixTime']){
							
							$row['remainder'] += $applicantCount;
							
						}
						
					}
					
				}
				
				$row['remainder'] -= $applicantCount;
				#print "key = ".$row['key']." unixTime = ".$row['unixTime']." time = ".$row['hour'].":".$row['min']." capacity = ".$row['capacity']." remainder = ".$row['remainder']."<br>";
				if($row['remainder'] < 0 || $row['stop'] == 'true'){
					
					$changeBool = false;
					return array('status' => 'error', 'event' => 'return', 'message' => 'There is not enough remainder in the capacity.');
					break;
					
				}else{
					
					if(is_null($scheduleDetail)){
						
						$scheduleDetail = $row;
						
					}
					
				}
				
			}
			
			if($changeBool === true){
				
				$newCourseTime = ($newTimeEnd - $newTimeStart) / 60;
				$oldCourseTime = ($oldTimeEnd - $oldTimeStart) / 60;
				#print "courseTime = ".$newCourseTime."<br>";
				#var_dump($scheduleDetail);
				
				if($mode == 'update'){
					
					$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC ;";
					$deleteValue = array(intval($accountKey), intval($oldTimeStart), intval($oldTimeEnd));
					if($oldTimeStart == $oldTimeEnd){
						
						$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
						$deleteValue = array(intval($accountKey), intval($updateScheduleKey));
						
					}
					
					/**
					if($status == "approved"){
						
						$this->updateRemainderSeart("delete", $deleteSql, $deleteValue, $applicantCount);
						$this->updateRemainderSeart("increase", $updateSql, $updateValue, $applicantCount);
						
					}
					**/
					
					$this->updateRemainderSeart("delete", $deleteSql, $deleteValue, $applicantCount);
					$this->updateRemainderSeart("increase", $updateSql, $updateValue, $applicantCount);
					
					$updateValue = array(
                            			'scheduleUnixTime' => intval($scheduleDetail['unixTime']), 
                            			'scheduleWeek' => intval($scheduleDetail['weekKey']), 
                            			'scheduleTitle' => $scheduleDetail['title'], 
                            			'scheduleCost' => intval($scheduleDetail['cost']), 
                            			'scheduleKey' => intval($scheduleDetail['key'])
                            		);
					
					if($newCourseTime != $oldCourseTime){
						
						$updateValue['courseKey'] = "exception";
						$updateValue['courseName'] = $newCourseTime." min";
						$updateValue['courseTime'] = intval($newCourseTime);
						
					}
					
					$table_name = $wpdb->prefix."booking_package_userPraivateData";
    				$bool = $wpdb->update(  $table_name,
                    	        			$updateValue,
                    	        			array('key' => intval($updateKey)),
                    	        			array('%d', '%d', '%s', '%d', '%d', '%s', '%s', '%d'),
                    	        			array('%d')
							);
					
				}else{
					
					return $changeBool;
					
				}
				
				
				
			}
    		
    	}
    	
    	public function updatePraivateData($id, $form){
    		
    		global $wpdb;
    		$form = json_encode($form);
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$bool = $wpdb->update(  $table_name,
                           			array(
                           				'praivateData' => $form
                           				),
                           			array('key' => intval($id)),
                           			array('%s'),
                           			array('%d')
					);
    		
    	}
    	
    	public function updateRemainderSeart($mode, $sql, $valueArray, $applicantCount = 1){
    		
    		if(is_null($sql)){
    			
    			return false;
    			
    		}
    		
    		global $wpdb;
    		$updateSchedule = array();
    		if($mode == "increase"){
    			
    			$sql = $wpdb->prepare($sql, $valueArray);
				$rows = $wpdb->get_results($sql, ARRAY_A);
				$valueArray = array();
				foreach($rows as $row){
					
					
					$waitingRemainder = 0;
					$remainder = $row['remainder'] - $applicantCount;
					if($row['stop'] == 'false' && $remainder >= 0){
						
						if(0 < $row['waitingRemainder']){
							
							$waitingRemainder = $row['waitingRemainder'] - $applicantCount;
							
						}
						
						array_push($valueArray, array('remainder' => intval($remainder), 'waitingRemainder' => intval($waitingRemainder), 'key' => intval($row['key'])));
						
					}else{
						
						return array('status' => 'error', 'error' => '9503');
						
					}
					
				}
				
				$table_name = $wpdb->prefix."booking_package_schedule";
				for($i = 0; $i < count($valueArray); $i++){
					
					$data = $valueArray[$i];
					$bool = $wpdb->update(  $table_name,
                           			array('remainder' => $data['remainder'], 'waitingRemainder' => $data['waitingRemainder']),
                           			array('key' => $data['key']),
                           			array('%d', '%d'),
                           			array('%d')
					);
					
					array_push($updateSchedule, $bool);
					
				}
    			
    		}else{
    			
    			$table_name = $wpdb->prefix."booking_package_schedule";
            	$sql = $wpdb->prepare($sql, $valueArray);
            	$rows = $wpdb->get_results($sql, ARRAY_A);
            	foreach($rows as $row){
            		
            		$remainder = $row['remainder'] + $applicantCount;
					$wpdb->update(  $table_name,
                           			array('remainder' => intval($remainder)),
                           			array('key' => intval($row['key'])),
                           			array('%d'),
                           			array('%d')
					);
            		
            		array_push($updateSchedule, $row['hour'].":".$row['min']." ".$remainder);
            			
            	}
    			
    		}
    		
    		return $updateSchedule;
    		
    	}
    	
    	public function getUserList($unixTime, $accountKey = 1){
    		
    		global $wpdb;
            
            $table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$sql = $wpdb->prepare("SELECT `key`,`scheduleUnixTime`,`scheduleKey`,`courseTime`,`status`,`applicantCount`,`praivateData`,`iCalIDforGoogleCalendar`,`praivateData` FROM ".$table_name." WHERE `iCalIDforGoogleCalendar` IS NOT NULL AND `accountKey` = %d AND `scheduleUnixTime` > %d ORDER BY `key` ASC;", array(intval($accountKey), intval($unixTime)));
            
            $rows = $wpdb->get_results($sql, ARRAY_A);
    		
    		return $rows;
    		
    	}
    	
    	public function getUserValues($accountKey){
    		
    		global $wpdb;
    		
    		$table_name = $wpdb->prefix."booking_package_form";
            $sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d;", array(intval($accountKey)));
            $row = $wpdb->get_row($sql, ARRAY_A);
    		$form = json_decode($row['data']);
    		for($i = 0; $i < count($form); $i++){
    			
    			if(isset($_POST['form'.$i])){
    				
    				if($form[$i]->required == 'true' && strlen($_POST['form'.$i]) == 0){
    					/** 必須項目の値がゼロの場合はエラーを返す **/
    					return array('status' => 'error', "message" => 'No text or select.', 'form' => $form[$i]);
    					
    				}else{
    					
    					if($form[$i]->isEmail == 'true' && strlen($_POST['form'.$i]) != 0 && !preg_match("/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/", $_POST['form'.$i])){
    						/** メールアドレスが正しい書式でないためエラーを返す **/
    						return array('status' => 'error', "message" => 'The format of the e-mail address is incorrect.', 'form' => $form[$i]);
    						
    					}else{
    						
    						$value = $_POST['form'.$i];
    						if($form[$i]->type == 'TEXTAREA'){
    							
    							$value = sanitize_textarea_field($value);
    							
    						}else{
    							
    							$value = sanitize_text_field($value);
    							
    						}
    						
    						if($form[$i]->isEmail == 'true'){
    							
    							$value = sanitize_email($value);
    							
    						}
    						
    						$form[$i]->value = $value;
    						
    					}
    					
    				}
    				
    			}
    			
    		}
    		
    		return $form;
    		
    	}
    	
    	public function emailFormat($email, $title = null){
    		
    		$value = $email;
    		if(!is_null($title) && strlen($title) != 0){
    			
    			$value = sprintf("%s <%s>", $title, $email);
    			
    		}
    		
    		return $value;
    		
    	}
    	
    	
    	public function dateFormat($dateFormat, $unixTime, $title){
    		
    		$dateFormat = intval($dateFormat);
    		if(is_null($title)){
    			
    			$title = '';
    			
    		}
    		
    		$date = date('l, d/m/Y H:i', $unixTime)." ".$title;
    		if($dateFormat == 0){
        		$date = date('l, m/d/Y H:i', $unixTime)." ".$title;
    		}else if($dateFormat == 1){
		        $date = date('l, m-d-Y H:i', $unixTime)." ".$title;
    		}else if($dateFormat == 2){
        		$date = date('l, F d, Y H:i', $unixTime)." ".$title;
    		}else if($dateFormat == 3){
        		$date = date('l, d/m/Y H:i', $unixTime)." ".$title;
    		}else if($dateFormat == 4){
        		$date = date('l, d-m-Y H:i', $unixTime)." ".$title;
    		}else if($dateFormat == 5){
        		$date = date('l, d F, Y H:i', $unixTime)." ".$title;
    		}else if($dateFormat == 6){
        		$date = date('l, Y/m/d H:i', $unixTime)." ".$title;
    		}else if($dateFormat == 7){
        		$date = date('l, Y-m-d H:i', $unixTime)." ".$title;
    		}
    		
    		return $date;
    		
    	}
    	
    	public function createEmailMessage($accountKey, $email_id, $form, $bookingID, $unixTime, $emailSubject, $emailBody, $emailFormat, $to, $from, $service = null, $scheduleTitle = null){
    		
    		global $wpdb;
    		
    		$to = $this->emailFormat(get_option($this->prefix."email_to", null), get_option($this->prefix."email_title_to", null));
    		$from = $this->emailFormat(get_option($this->prefix."email_from", null), get_option($this->prefix."email_title_from", null));
    		
    		$table_name = $wpdb->prefix."booking_package_emailSetting";
    		for($i = 0; $i < count($email_id); $i++){
    			
    			$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `mail_id` = %s;", array(intval($accountKey), $email_id[$i]));
                $row = $wpdb->get_row($sql, ARRAY_A);
                if(intval($_POST['sendEmail']) == 1){
                	
                	$emailSubject = $row['subject'];
                	$emailBody = $row['content'];
                	$emailFormat = $row['format'];
                	if(intval($row['enable']) == 0){
                		
                		return null;
                		
                	}
                	
                }
    			
    		}
    		
    		$mailBody = stripslashes($mailBody);
    		$emailBody = preg_replace('/\\\/u', "", $emailBody);
    		
    		$site_name = get_option($this->prefix."site_name", "");
    		$dateFormat = intval(get_option($this->prefix."dateFormat", 0));
    		$date = $this->dateFormat($dateFormat, $unixTime, $scheduleTitle);
    		if (preg_match('/(\[date\])/', $emailBody, $matches)) {
    			
    			$emailBody = preg_replace('/(\[date\])/', $date, $emailBody);
    			
    		}
    		
    		if (preg_match('/(\[id\])/', $emailBody, $matches)) {
    			
    			$emailBody = preg_replace('/(\[id\])/', $bookingID, $emailBody);
    			
    		}
    		
    		if (preg_match('/(\[site_name\])/', $emailBody, $matches)) {
    			
    			$emailBody = preg_replace('/(\[site_name\])/', $site_name, $emailBody);
    			
    		}
    		
    		if(!is_null($service) && strlen($service) != 0){
    			
    			if(preg_match('/(\[service\])/', $emailBody, $matches)) {
    				
    				$emailBody = preg_replace('/(\[service\])/', $service, $emailBody);
    				
    			}
    			
    		}
    		
    		
    		
    		$visitorEmail = array();
    		$content = "";
    		for($i = 0; $i < count($form); $i++){
    			
    			
    			if($emailFormat == "text"){
    				
    				$content .= $form[$i]->name."\r\n".$form[$i]->value."\r\n";
    				
    			}else{
    				
    				$content .= '<div style="width: 100%; display: table;"><div style="width: 30%; display: table-cell; vertical-align: middle;">'.$form[$i]->name.'</div><div style="width: 70%; display: table-cell; vertical-align: middle;">'.$form[$i]->value.'</div></div>';
    				#$content .= '<div style="width: 30%; display: table-cell; vertical-align: middle;">'.$form[$i]->name.'</div><div style="width: 70%; display: table-cell; vertical-align: middle;">'.$form[$i]->value.'</div>';
    				
    			}
    			
    			if($form[$i]->isEmail == 'true'){
    				
    				array_push($visitorEmail, $form[$i]->value);
    				
    			}
    			
    		}
    		
    		if (preg_match('/(\[content\])/', $emailBody, $matches)) {
    			
    			$emailBody = preg_replace('/(\[content\])/', $content, $emailBody);
    			
    		}
    		
    		for($i = 0; $i < count($form); $i++){
    			
    			$id = '\['.$form[$i]->id.'\]';
    			#$value = $form[$i]->name."\n".$form[$i]->value."\n";
    			$value = $form[$i]->value."\n";
    			if (preg_match('/('.$id.')/', $emailBody, $matches)) {
    				
    				$emailBody = preg_replace('/('.$id.')/', $value, $emailBody);
    			
    			}
    			
    		}
    		
    		$headers = array("From: ".$from."\r\n", "Return-Path: ".$from."\r\n", "Reply-To: ".$from."\r\n");
    		
    		if($emailFormat == "text"){
    			
    			$emailBody = strip_tags($emailBody);
    			
    		}else{
    			
    			array_push($headers, "Content-Type: text/html; charset=UTF-8");
    			$bodyStyle = 'word-wrap: break-word; white-space: pre;';
    			$header = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
    			$header .= '<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>Booking email</title></head>';
    			$header .= '<body style="'.$bodyStyle.'">';
    			$emailBody = $header.$emailBody."</body></html>";
    			
    		}
    		
    		$responseList = array('body' => $emailBody, 'to' => $to, 'from' => $from, 'sendVisitor' => $sendVisitor, 'headers' => $headers, 'visitorEmail' => $visitorEmail, 'response' => array(), 'params' => array());
    		
    		mb_language("uni");
			mb_internal_encoding("UTF-8");
    		
    		$mailgun_active = intval(get_option($this->prefix."mailgun_active", 0));
    		if($mailgun_active == 1){
    			
    			$mailgun_aip_base_url = get_option($this->prefix."mailgun_aip_base_url", 0);
    			$mailgun_api_key = get_option($this->prefix."mailgun_api_key", 0);
    			$mailgun_password = get_option($this->prefix."mailgun_password", 0);
    			#var_dump($mailgun_api_key);
    			
    			$params = array('from' => $from, 'to' => implode(",", $visitorEmail), 'subject' => $emailSubject);
    			if($emailFormat == "text"){
					
					$params['text'] = $emailBody;
					
				}else{
					
					$params['html'] = $emailBody;
					
				}
				$responseList['params']['visitor'] = $params;
    			if(count($visitorEmail) != 0){
    				
					$paramsQuery = http_build_query($params);
					#$params = json_encode($params);
					$context = array(
						'http' => array(
							'method' => 'POST', 
							'header' => "Content-Type: application/x-www-form-urlencoded\r\n".
							"Content-Length: ".strlen($paramsQuery)."\r\n".
							"User-Agent: PHP\r\n".
							"Host: api.mailgun.net\r\n".
							"Authorization: Basic ".base64_encode("api:".$mailgun_api_key),
							'content' => $paramsQuery
						)
					);
					
					$context = stream_context_create($context);
					$response = file_get_contents($mailgun_aip_base_url.'/messages', false, $context);
					$responseList['response']['visitor'] = $response;
					
    			}
    			
    			$params['to'] = $to;
    			$responseList['params']['admin'] = $params;
    			$paramsQuery = http_build_query($params);
				$context = array(
					'http' => array(
						'method' => 'POST', 
						'header' => "Content-Type: application/x-www-form-urlencoded\r\n".
						"Content-Length: ".strlen($paramsQuery)."\r\n".
						"User-Agent: PHP\r\n".
						"Host: api.mailgun.net\r\n".
						"Authorization: Basic ".base64_encode("api:".$mailgun_api_key),
						'content' => $paramsQuery
					)
				);
				
				$context = stream_context_create($context);
				$response = file_get_contents($mailgun_aip_base_url.'/messages', false, $context);
				$responseList['response']['admin'] = $response;
    			
    		}else{
    			
    			$sendVisitor = false;
    			if(count($visitorEmail) != 0){
    				
    				$sendVisitor = wp_mail($visitorEmail, $emailSubject, $emailBody, $headers);
    				
    			}
    			wp_mail($to, $emailSubject, $emailBody, $headers);
    			
    		}
    		
    		return $responseList;
    		
    	}
        
        
    }
    
    
    
    
    
    
?>